// ClientPlayer.h: interface for the CClientPlayer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLIENTPLAYER_H__E42BCC64_085E_11D3_924F_0060971BFDA2__INCLUDED_)
#define AFX_CLIENTPLAYER_H__E42BCC64_085E_11D3_924F_0060971BFDA2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "client_objects.h"

class CClientPlayer : public CClientObjects  
{
public:
	virtual BOOL IsHero();
	virtual void SetHero();
	//Returns the index into the centerCube array for the
	//given index into the Rubiks cube.
	virtual int  GetCenterIndex(int index);
	//The opposite of the above function
	virtual int  GetCubeIndex(int index);
	virtual CubeWeapon GetCurrentWeapon() { return currentWeapon;}


	virtual int getHitpoints() { return info.hitpoints;}

	virtual void PickupPiece(PieceType piece);
	virtual void DropPiece(PieceType piece);
	virtual BOOL IsPlayer();
	virtual PieceType GetCenterCube(int index);
	virtual int GetTeam() { return team; }
	virtual SetTeam(int newteam) { team = newteam; }
	virtual BOOL IsMultiShot() { return multi_shot;}
	virtual BOOL IsRicochete() { return ricochete; }
	//Let's make the name public since we want to change it from user input
	char name[10];

protected:

	virtual void getPlayerIcon(LPDIRECT3DRM3 rm, LPLPDIRECT3DRMFRAME3 frame, 
							   LPDIRECT3DRMFRAME3 parent, bool isDrEvil=true);

	BOOL bHero;
	CubeWeapon currentWeapon;
	BOOL multi_shot;
	BOOL ricochete;

	int team; //Which of the 2 teams your on
	BOOL centerCube[6]; //Which of the center cubes we have
};

#endif // !defined(AFX_CLIENTPLAYER_H__E42BCC64_085E_11D3_924F_0060971BFDA2__INCLUDED_)
