#ifndef __CLIENTRUBIKSPIECE_H__
#define __CLIENTRUBIKSPIECE_H__

#include "client_objects.h"
#include "rubiksSoundset.h"
#include "RubiksSoundSet.h"
#include "SoundTypes.h"

class CClientRubiksPiece : CClientObjects {

	public:

		CClientRubiksPiece (LPDIRECT3DRM3 lpD3DRM, LPDIRECT3DRMFRAME3 Parent, Position * pos, float orientation, 
							PieceType type, PieceType PlayerType, SoundSet *pSS = NULL );
		/* Function to respond to a message. All objects will
		   receive the same message (a rubiks_info struct), but
		   some of them may ignore certain variables. */
		//virtual void ReceiveMessage(rubiks_info* info);
		virtual void ReceiveMessage(rubiks_info* info);
		
		/* Function called every time the object should update
		   its frame. This will probably be called in RenderFrame
		   shortly after a ReceiveMessage call was made. */
		//virtual void Update();
		virtual void Update();

		void RemoveSound(); // Play sound when piece is removed
		BOOL IsRubiksPiece() { return TRUE;}
	
	protected:
		LPDIRECT3DRMFRAME3 parent_frame ;
		//rubiks_info info;
	
		float size;
		SoundSet * pSoundSet;
};


#endif //__CLIENTRUBIKSPIECE_H__