/**
  *
  * RubiksCube.h  -- Defines a class that draws a Rubiks Cube in
  *                  Direct3D.
  *
  * Author: Kevin Audleman
  *
  */

#ifndef  __CLIENT_VIEWER__
#define  __CLIENT_VIEWER__


#include <windows.h>   // Standard Windows header file 
#include <direct.h>    // DirectDraw definitions 
#include <d3drmwin.h>  // D3DRM definitions 
#include <ddraw.h>

#include <stdio.h>
#include <math.h>
#include <assert.h>

#include "rubiksInfo.h"
#include "colors.h"
#include "client_objects.h"
#include "RubiksSoundSet.h"
#include "SoundTypes.h"
#include "ClientPlayer.h"

#ifndef RELEASE
#define RELEASE(x) if (x != NULL) { x->Release(); x = NULL; } 
#endif

// Macro to display a message box containing the given string. 
#ifndef DISPLAYMSG
//#define DISPLAYMSG(x) MessageBox(NULL, x, "Rubiks ICON", MB_OK);
#define DISPLAYMSG(x) OutputDebugString(x)
#endif


class CClientViewer: public CClientPlayer{

public:
	BOOL UpdateListener();
	virtual void DoSound();
	SoundSet *pSoundSet;
	CClientViewer(LPDIRECT3DRM3 rm, LPDIRECT3DRMFRAME3 parent, Position* pos, 
				  float orientation, SoundSet *pSS = NULL );
	CClientViewer();
	virtual ~CClientViewer();

	//Sets our information based on the message we receive
	virtual void ReceiveMessage(rubiks_info *message);

	//Call this function every time the Player app wants
	//to refresh this cube. 
	virtual void Update();


	
	BOOL bPlayedSound;
protected:
	D3DVECTOR vTop;
	D3DVECTOR vFront;
	//Frames
	LPDIRECT3DRMFRAME3 parent_frame;
	BOOL modified;  //Set when ReceiveMessage is called
	
	//All of the information for this block. This is the message that
	//will be passed in between the server and player.
	//rubiks_info *info;

private:

};

#endif //__CLIENT_VIEWER__