#include <d3drmwin.h>
#include <math.h>
#include "rodcone.h"
#include "RubicsDirect3D.h"

/*	glLoadIdentity();
	glTranslated( 0.0, 0.0, -zoom);
    glPushMatrix();
	
	//For Black Wins Animation
	glTranslated(0,height, 0);
	glRotated(rotation, 1,0,0);
	glRotated(tilt, 0,1,0);


	//glTranslated(x-width,y,z);
	
	double width = 0.25;

	double depth = 0.1;
	double seperation = 1.6;
	
	float stuff[4];

	stuff[0] = 0;
	stuff[1] = 0;
	stuff[2] = 0;
	stuff[3] = 1;
	glLightfv(GL_LIGHT1,GL_POSITION,stuff);
	glLightfv(GL_LIGHT2,GL_POSITION,stuff);

	glTranslated(-(seperation+0.1)/2, 0,0);
	   
	ConnectFourBase(seperation+0.1, 1.25 * seperation,width);

	
	/*ConnectArms(arm2_slide,arm2_rotation,width,depth,separation/4.0,separation + width);
	glTranslated(width*3.0/4.0 + separation/2.0,0.0,-depth/2.0);
	
	  
	 ConnectFourBoard(depth,depth/5.0,6,8,,(separation + width/2.0)/16.0,(separation + width/2.0)/17.0,10);
	DrawPieces(pieces,distance);
	glTranslated(-0.05, 0.675 * seperation,0+0.15);


	ConnectArms(slide, arm_rotation, 0.05, 0.15, 0.7, 0.15+ seperation);
	glTranslated((seperation  + width)/2.0,0, 0);
	glRotated(board_rotation, 1,0,0);
	ConnectFourBoard(depth, depth/4, 8, 8, (seperation  +0.1)/16.0, (seperation  +0.1)/16.0, 0.0825, 5);
	//DrawPieces(pieces);
	glTranslated(-(seperation  +0.1)/2+(seperation  +0.1)/16, (seperation  +0.1)/2-(seperation  +0.1)/16, 0);
	DrawPieces(pieces,distance, 2.0* (seperation  +0.1)/16);
	
	//ConnectFourQuarterCircle( 2, 2, 1, 0.1, 10 );
    glPopMatrix();
    
    return TCL_OK;
}

int CurrentColor(BOOL place) {
	if(place)
		return RED;
	else 
		return BLACK;
}

bool OnBoard(int x,int y) {
	return (8 > x && x >= 0 && 8 > y && y >= 0);
}

int CheckWinAt(int pieces[][8], int x, int y) {
	//only need to check half the directions.
	const int x_dir[4] = {1,1,1,0};
	const int y_dir[4] = {-1,0,1,1};
	int color = pieces[y][x];
	if (!color)
		return color;

	for(int i = 0; i< 4; i++) {
		for(int j = 1; j< 5; j++) {
			if(j == 4)
				return color;
			if(OnBoard(j*x_dir[i] + x, j*y_dir[i] + y)) {
				if(pieces[j*y_dir[i] + y][j*x_dir[i] + x] != color) {
					break;
				}
			} else break;
		}
	}
	return 0;

}

int CheckWin(int pieces[][8]) {
	int win;
	for(int i = 0; i< 8; i++) {
		for(int j = 0; j< 8; j++) {
			win = CheckWinAt(pieces, i, j);
			if (win) return win;
		}

	}
	return 0;

}

bool PlacePiece(int pieces[][8], float distance[][8], float velocity[][8], int column, int color) {
	if(column > 7 || column < 0)
		return false;
	for(int i = 0; i< 8; i++) {
		if (!pieces[column][i]) {
			pieces[column][i] = color;
			//if(get_time())
				distance[column][i] = DEFAULT_DISTANCE;
			//else 
			//	distance[column][i] = 0;
			velocity[column][i] = DEFAULT_VELOCITY;
			return true;
		}

	}
	return false;
}

void MovePieces(int pieces[][8], float distance[][8], float velocity[][8], double change_time) {
	for(int i = 0; i< 8; i++) {
		for(int j = 0; j< 8; j++) {
			if(velocity[i][j] < 0) {
				distance[i][j] += change_time * velocity[i][j];
				if (distance[i][j] < 0 ) {
					distance[i][j] = 0;
					velocity[i][j] = 0;
				}
			} else if(velocity[i][j] > 0){

				distance[i][j] += change_time *velocity[i][j];
				if (distance[i][j] > MAX_DISTANCE ) {
					distance[i][j] = 0;
					pieces[i][j]= 0;
					velocity[i][j]= 0;
				}
			} else {
	
			}
		}

	}
	return;
}

void DrawPieces(int pieces[][8], float distance[][8], double square_size) {
	glDisable(GL_LIGHT1);
	float stuff[4];
	for(int i = 0; i < 8; i++) {
		for(int j = 0; j < 8; j++) {
			if(pieces[j][i] == RED ) {
				ambient_color( 0.7, .1, .1); 
				diffuse_color( 0.5,.1, .1); 
				specular_color(0.9,.1, .1);
				DrawPiece(j, i, distance[j][i], square_size);
			} else if(pieces[j][i] == BLACK) {
				ambient_color( .1, .1, 0.7); 
				diffuse_color( .1, .1, 0.5); 
				specular_color( .1, .1, 0.9);

				DrawPiece(j, i, distance[j][i], square_size);
			}
		}
	}
}


void DrawPiece(int x, int y, float distance,double square_size) {
	glPushMatrix();
	glTranslated(square_size * x, -square_size*(y + distance), 0);
	glScaled(PIECE_RADIUS,PIECE_RADIUS,PIECE_HEIGHT);
	cylinder(1.0, 1.0, 1.0);	
	glPopMatrix();
}




void Joints(double width, double length, double seperation) {
	glPushMatrix();
	glRotated(90,  0,1,0);
	ambient_color( 0, 0, 0.0); 
	diffuse_color( 0.0, 0.0, 0.3); 
	specular_color( 0.0, 0.0, 0.5);
	cylinder( width, length, length);
	glTranslated( 0,0, seperation);
	cylinder( width, length, length);
	glPopMatrix();
}
	


void ConnectArms(double arm_slide, double arm_rotation, double width, double length, double height, double seperation) {
	//box(0,0,0, ARM1_WIDTH, ARM1_LENGTH, ARM1_HEIGHT);
	//glTranslated(0, 0 , ARM1_LENGTH/2);
	
	glRotated(arm_rotation,1.0,0.0,0.0);
	glPushMatrix();
	//ambient_color( 0, 0, 0); 
	//ambient_color( 0.1, 1.0, 1.0);  
	shininess( 0.2); 

	glPushMatrix();
	//glTranslated(-width,0,0);
	Joints(width, 0.875* length, seperation);
	
	ambient_color( 0, 0, 0.7); 
	diffuse_color( 0, 0, 0.3); 
	specular_color( 0, 0, 1.0);

	ConnectArmSection(width, length, height);
	glTranslated(seperation ,0, 0);

	ConnectArmSection(width, length, height);
	glPopMatrix();
	glPushMatrix();
	
	glTranslated(0,0, -height + arm_slide );
	//glTranslated(-width,0,0);

	ConnectArmSection(width, length/2, height);
	glTranslated(seperation ,0, 0);
	ConnectArmSection(width, length/2, height);
	glPopMatrix();
	//glTranslated(0.0,0.0,arm2_slide);
	glPopMatrix();
	glTranslated(0,0, -2*height + arm_slide );
}

void ConnectArmSection(double width, double length, double height) {
	glPushMatrix();
	glRotated(90,  0,1,0);
	cylinder( width, length/2, length/2);
	glTranslated(0,-length/2, 0);
	box(height, length,width);
	glTranslated(height,length/2, 0);
	cylinder( width, length/2, length/2);
	glPopMatrix();
}

void ConnectFourBoard(double Depth, double FaceDepth, int NumRows, int NumColumns, double width, double height, double radius, int NumSidesInCircle){
    glPushMatrix();
	
    ambient_color( 1.0, 1.0, 0); 
	diffuse_color( 1.0,1.0, 0); 
	specular_color( 1.0, 1.0, 0); 
	shininess( 0.8); 


	glPushMatrix();
	glTranslated(-width*NumColumns, -height*NumRows, 0);
	
	box(FaceDepth, 2*height*NumRows, Depth);
	glTranslated(2*width*NumColumns, 0, 0);
	//glScaled(0,-1,0);
	//glRotated(180, 0,1,0);
	glTranslated(-FaceDepth, 0, 0);
	box(FaceDepth, 2*height*NumRows, Depth);
	//glTranslated(0, 2*width*NumColumns, 0);
	//DrawRectangle(Depth, height*2*NumRows);
	glPopMatrix();
	
	glPushMatrix();
	glTranslated(-width*NumColumns, -height*NumRows, 0);
	//glRotated(90, 0, 1, 0);
	//box(Depth, height*2*NumRows);
	box(2*width*NumColumns, FaceDepth/2, FaceDepth);
	glTranslated(0, 0, Depth-FaceDepth);
	box(2*width*NumColumns, FaceDepth/2, FaceDepth);
	
	glTranslated(0, 2*height*NumRows-FaceDepth/2, 0);

	box(2*width*NumColumns, FaceDepth/2, FaceDepth);
	glTranslated(0, 0, -Depth+FaceDepth);
	box(2*width*NumColumns, FaceDepth/2, FaceDepth);
	//glTranslated(0, 2*width*NumColumns, 0);
	//DrawRectangle(Depth, height*2*NumRows);
	glPopMatrix();

	glTranslated(-width*NumColumns, -height*NumRows, 0);
	glTranslated(0, 0 , FaceDepth);
	ConnectFourFace(NumRows, NumColumns, width, height, radius, FaceDepth, NumSidesInCircle);
	glTranslated(0, 0 , Depth-2*FaceDepth);
	ConnectFourFace(NumRows, NumColumns, width, height, radius, FaceDepth, NumSidesInCircle);

	//glTranslated(0, 0 , -FaceDepth);
	//ConnectFourFace(NumRows, NumColumns, width, height, radius, NumSidesInCircle);
	glPopMatrix();
}

void DrawRectangle(double width, double height) {
	glPushMatrix();
	triangle(0, 0, 0, width, 0, 0, 0, height, 0);	
	triangle(width, height, 0, width, 0, 0, 0, height, 0);	
	glPopMatrix();
}

void DrawRectangle(double x1, double y1, double x2, double y2, double depth)  {
	triangle(x1, y1, 0, x1, y1, -depth, x2, y2, -depth);	
	triangle(x2, y2, -depth, x2, y2, 0, x1, y1, 0);	
}
*/
void box(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float x1, float y1,float z1, float x2, float y2,float z2) {
	LPDIRECT3DRMFACE2 face = NULL;
	HRESULT hr;

	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	face->AddVertex(x1, y1, z1);
	face->AddVertex(x1, y1, z2);
	face->AddVertex(x1, y2, z2);
	face->AddVertex(x1, y2, z1);
	RELEASE(face);
	
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x2, y2, z1);
	face->AddVertex(x2, y2, z2);
	face->AddVertex(x2, y1, z2);
	face->AddVertex(x2, y1, z1);
	RELEASE(face);
	
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x1, y1, z1);
	face->AddVertex(x1, y2, z1);
	face->AddVertex(x2, y2, z1);
	face->AddVertex(x2, y1, z1);
	RELEASE(face);
	
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x2, y1, z2);
	face->AddVertex(x2, y2, z2);
	face->AddVertex(x1, y2, z2);
	face->AddVertex(x1, y1, z2);
	RELEASE(face);

	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x1, y2, z1);
	face->AddVertex(x1, y2, z2);
	face->AddVertex(x2, y2, z2);
	face->AddVertex(x2, y2, z1);
	RELEASE(face);
	
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x2, y1, z1);
	face->AddVertex(x2, y1, z2);
	face->AddVertex(x1, y1, z2);
	face->AddVertex(x1, y1, z1);
	RELEASE(face);
	return;
}

void box(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float theta, float x2, float y2,float z2) {
	float sin_theta = sin(theta);
	float cos_theta = cos(theta);
		
	//box(meshbuilder, x1, y1,z1, x2, y2,z2);
	LPDIRECT3DRMFACE2 face = NULL;
	HRESULT hr;

	/*if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	face->AddVertex(0, 0, 0);
	face->AddVertex(0, 0, z2);
	face->AddVertex(0, z2*sin_theta+y2, z2*cos_theta);
	face->AddVertex(0, z2*sin_theta, z2*cos_theta);
	RELEASE(face);*/
	
	/*
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	face->AddVertex(x2, z2*sin_theta, z2*cos_theta );
	face->AddVertex(x2, z2*sin_theta+y2, z2*cos_theta);
	face->AddVertex(x2, 0, z2);
	face->AddVertex(x2, 0, 0);
	RELEASE(face);
	*/
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(0, 0, 0);
	face->AddVertex(0, z2*sin_theta, z2*cos_theta);
	face->AddVertex(x2, z2*sin_theta, z2*cos_theta);
	face->AddVertex(x2, 0, 0);
	RELEASE(face);
	
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x2, 0, 0);
	face->AddVertex(x2, z2*sin_theta+y2, z2*cos_theta);
	face->AddVertex(0, z2*sin_theta+y2, z2*cos_theta);
	face->AddVertex(0, 0,0);
	RELEASE(face);

	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(0, z2*sin_theta, z2*cos_theta);
	face->AddVertex(0, z2*sin_theta+y2, z2*cos_theta);
	face->AddVertex(x2, z2*sin_theta+y2, z2*cos_theta);
	face->AddVertex(x2, z2*sin_theta, z2*cos_theta);
	RELEASE(face);
	
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	
	face->AddVertex(x2, 0, 0);
	face->AddVertex(x2, 0, z2);
	face->AddVertex(0, 0, z2);
	face->AddVertex(0, 0, 0);
	RELEASE(face);
	return;
}


void triangle(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float x1, float y1, float z1,float x2, float y2, float z2,float x3, float y3, float z3) {
	LPDIRECT3DRMFACE2 face = NULL;
	HRESULT hr;
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	face->AddVertex(x1, y1, z1);
	face->AddVertex(x2, y2, z2);
	face->AddVertex(x3, y3, z3);
	RELEASE(face);
}

void DrawRectangle(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float x1, float y1, float x2, float y2, float depth) {
	LPDIRECT3DRMFACE2 face = NULL;
	HRESULT hr;
	if (FAILED(hr = meshbuilder->CreateFace(&face))) {
		return;
	}
	face->AddVertex(x1, y1, 0 );
	face->AddVertex(x1, y1, -depth);
	face->AddVertex(x2, y2, -depth);
	face->AddVertex(x2, y2, 0);
	RELEASE(face);
}

void ConnectFourQuarterCircle(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float width, float height, float radius, float depth, int NumSidesInCircle ) {
	const float PI = 3.14159;
	
	float last_x, last_y, main_x, main_y, current_x, current_y, CenterX, CenterY, theta, delta_theta;
	int i;
	if(NumSidesInCircle > 0) {
		//Do top make sure normal is facing up.
		//This will matter in direct 3d;
		//Make a triangle fan from this point.
		main_x = -width;
		main_y = -height;
		
		CenterX = 0;
		CenterY = 0;
		theta = 0.0;
	
		delta_theta = (PI / 2.0) / NumSidesInCircle;
		theta = PI;

		last_x = CenterX + radius * cos(theta);
		last_y = CenterY + radius * sin(theta);
		theta += delta_theta;

		triangle(meshbuilder, main_x, main_y, -depth, -width, 0, -depth, last_x, last_y, -depth);

		for(i = 0 ; i < NumSidesInCircle; i++) {
			current_x = CenterX + radius * cos(theta);
			current_y = CenterY + radius * sin(theta);

			triangle(meshbuilder, main_x, main_y, -depth, last_x, last_y, -depth, current_x, current_y, -depth);
			DrawRectangle(meshbuilder, current_x, current_y, last_x, last_y, depth);
			theta += delta_theta;
			last_x = current_x;
			last_y = current_y;
		}
		triangle(meshbuilder, main_x, main_y, -depth, last_x, last_y, -depth, 0, -height, -depth);

		delta_theta = -((PI / 2.0) / NumSidesInCircle);
		
		theta = - PI / 2.0;

		last_x = CenterX + radius * cos(theta);
		last_y = CenterY + radius * sin(theta);
		theta += delta_theta;

		triangle(meshbuilder, main_x, main_y, 0, 0, -height, 0 , last_x, last_y, 0);
		
		for(i = 0 ; i < NumSidesInCircle; i++) {
			current_x = CenterX + radius * cos(theta);
			current_y = CenterY + radius * sin(theta);

			triangle(meshbuilder, main_x, main_y, 0, last_x, last_y, 0, current_x, current_y, 0);
			theta += delta_theta;
			last_x = current_x;
			last_y = current_y;
		}
		triangle(meshbuilder, main_x, main_y, 0, last_x, last_y, 0, -width, 0, 0);

	}
}

void ConnectFourCircle(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float width, float height, float radius, float depth, int NumSidesInQuarterCircle ) {
	HRESULT hr;
	LPDIRECT3DRMMESH mesh = NULL;
	ConnectFourQuarterCircle(meshbuilder, width, height, radius, depth, NumSidesInQuarterCircle);
	hr = meshbuilder->CreateMesh(&mesh);
	hr = mesh->Scale(  -1.0f,  1.0f,  -1.0f);
	hr = mesh->Translate(0,0, -depth);
	hr = meshbuilder->AddMesh(mesh);
	RELEASE(mesh);
	hr = meshbuilder->CreateMesh(&mesh);
	hr = mesh->Scale(  1.0f,  -1.0f,  -1.0f);
	hr = mesh->Translate(0,0, -depth);
	hr = meshbuilder->AddMesh(mesh);
	RELEASE(mesh);
	return ;
	//	glScalef(-1.0,1.0,1.0);
	/*ConnectFourQuarterCircle( width, height, radius, depth, NumSidesInQuarterCircle);
	glRotated(90, 0,0,1);
	ConnectFourQuarterCircle( width, height, radius, depth, NumSidesInQuarterCircle);
	glRotated(90, 0,0,1);
	ConnectFourQuarterCircle( width, height, radius, depth, NumSidesInQuarterCircle);
	glPopMatrix();*/
}
void ConnectFourRow(LPDIRECT3DRMMESHBUILDER3 meshbuilder, int NumColumns, double width, double heigth, double radius, double depth, int NumSidesInQuarterCircle) {
	HRESULT hr;
	LPDIRECT3DRMMESH mesh = NULL;
	LPDIRECT3DRMMESHBUILDER3 meshbuilder1 = NULL;

	hr = meshbuilder->Clone(NULL,IID_IDirect3DRMMeshBuilder3, (void **)&meshbuilder1);

	//Translated(width, 0, 0);
	ConnectFourCircle(meshbuilder1, width, heigth, radius, depth, NumSidesInQuarterCircle);
	hr = meshbuilder1->CreateMesh(&mesh);
	for(int i = 0; i < NumColumns; i++) {
		hr = meshbuilder->Translate(-2*width, 0, 0);
		hr = meshbuilder->AddMesh(mesh);
	}
}


void ConnectFourFace(LPDIRECT3DRMMESHBUILDER3 meshbuilder, int NumRows, int NumColumns, double width, double height, double radius, double Depth, int NumSidesInQuarterCircle) {
	HRESULT hr;
	LPDIRECT3DRMMESH mesh = NULL;
	LPDIRECT3DRMMESHBUILDER3 meshbuilder1 = NULL;
	
	hr = meshbuilder->Clone(NULL,IID_IDirect3DRMMeshBuilder3,(void **)&meshbuilder1);
	//glTranslated(0, height, 0);
	
	box(meshbuilder1, -2*width*NumColumns+width, height+Depth/2, -Depth, width,height,0);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	ConnectFourRow(meshbuilder1, NumColumns, width, height, radius, Depth, NumSidesInQuarterCircle);
	hr = meshbuilder1->CreateMesh(&mesh);
	for(int i = 0; i < NumRows; i++) {
		hr = meshbuilder->Translate(0, -height*2, 0);
		hr = meshbuilder->AddMesh(mesh);
	}
	meshbuilder1->Empty(0);	
	box(meshbuilder1, -2*width*NumColumns+width, height-Depth/2, -Depth, width, height,0);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
}

void ConnectFourBoard(LPDIRECT3DRMMESHBUILDER3 meshbuilder, double Depth, double FaceDepth, int NumRows, int NumColumns, double width, double height, double radius, int NumSidesInCircle){
    HRESULT hr;
	LPDIRECT3DRMMESH mesh = NULL;
	LPDIRECT3DRMMESHBUILDER3 meshbuilder1 = NULL;
	
	hr = meshbuilder->Clone(NULL,IID_IDirect3DRMMeshBuilder3,(void **)&meshbuilder1);
	//glTranslated(0, height, 0);
	
	box(meshbuilder1, width-FaceDepth, height, -Depth+FaceDepth, width,2*height*NumRows+height,0);
	
//	glTranslated(0, 2*height*NumRows-FaceDepth/2, 0);


	meshbuilder->Translate(0, 0 , FaceDepth);
	ConnectFourFace(meshbuilder1, NumRows, NumColumns, width, height, radius, FaceDepth, NumSidesInCircle);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	box(meshbuilder1, width-FaceDepth, height, -Depth+FaceDepth, width,2*height*NumRows+height,0);
	meshbuilder1->Translate(-2*width*NumColumns+FaceDepth, -2*height*NumRows, 0);
	hr = meshbuilder1->CreateMesh(&mesh);
	meshbuilder1->Empty(0);
	hr = meshbuilder->AddMesh(mesh);
	//box(meshbuilder, 2*width*NumColumns+width-2*FaceDepth, height, -Depth+FaceDepth, 2*width*NumColumns + width -FaceDepth,2*height*NumRows+height,0);
	meshbuilder->Translate(0, 0 , Depth-2*FaceDepth);
	ConnectFourFace(meshbuilder1, NumRows, NumColumns, width, height, radius, FaceDepth, NumSidesInCircle);	
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
}



void ConnectArmSection(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float width, float length, float height) {
	D3DVECTOR a = {0,0,0}, b = {0,0,0};
	a.y = width;
	//a.x = width;
	b.z = width;
	b.y = width;
	//b.x = width;

	AddRod(meshbuilder, length/2, a, b);
	box(meshbuilder, -length/2, 0,0, length/2, height, width );
	meshbuilder->Translate(0,-height, 0);
	AddRod(meshbuilder, length/2, a, b);
}
void ConnectArmSectionPair(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float seperation, float width, float length, float height) {
	HRESULT hr;
	LPDIRECT3DRMMESH mesh = NULL;
	LPDIRECT3DRMMESHBUILDER3 meshbuilder1 = NULL;
	
	hr = meshbuilder->Clone(NULL,IID_IDirect3DRMMeshBuilder3,(void **)&meshbuilder1);
	ConnectArmSection(meshbuilder1, width, length, height);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	meshbuilder->Translate(0,0, seperation-width);
	ConnectArmSection(meshbuilder1, width, length, height);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder->Translate(0,0, -seperation/2);
}
void triangle_box(LPDIRECT3DRMMESHBUILDER3 meshbuilder, float width,float y,float z)
{
	triangle(meshbuilder,0.0,y,0.0,0.0,0.0,0.0,0.0,0.0,z);
	triangle(meshbuilder,width,0.0,0.0,width,y,0.0,width,0.0,z);

	//triangle(meshbuilder, 0.0,0.0,0.0,width,0.0,0.0,width,0.0,z);
	//triangle(meshbuilder, 0.0,0.0,0.0,0.0,0.0,z,width,0.0,z);

	triangle(meshbuilder, width,0.0,0.0,0.0,0.0,0.0,width,y,0.0);
	triangle(meshbuilder, 0.0,0.0,0.0,0.0,y,0.0,width,y,0.0);
	triangle(meshbuilder, 0.0,y,0.0,width,y,0.0,width,0.0,z);
	triangle(meshbuilder, 0.0,0.0,z,0.0,y,0.0,width,0.0,z);

}



void ConnectFourBase(LPDIRECT3DRMMESHBUILDER3 meshbuilder, double width, float length, double depth, double height)
{
	const float PI = 3.14159;
	HRESULT hr;
	LPDIRECT3DRMMESH mesh = NULL;
	LPDIRECT3DRMMESHBUILDER3 meshbuilder1 = NULL;
	
	hr = meshbuilder->Clone(NULL,IID_IDirect3DRMMeshBuilder3,(void **)&meshbuilder1);
	//glTranslated(-width/2.0f,0.0,0.0);; 

//	glTranslated(0.0,height,0.0);
	//meshbuilder->Translate(0.0,0.0,height);
	triangle_box(meshbuilder1, width/100.0f,height,height);
	meshbuilder1->Scale(1,-1, -1);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	meshbuilder->Translate(width - width/100.0f,0.0,0.0);
	triangle_box(meshbuilder1, width/100.0f,height,height);
	meshbuilder1->Scale(1,-1, -1);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	meshbuilder->Translate(0.0,0.0,/*depth - 2.0f * height*/-length);
	triangle_box(meshbuilder1, width/100.0f,height,height);
	meshbuilder1->Scale(-1, -1,1);
	meshbuilder1->Translate(width/100.0f,0.0,0.0);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	meshbuilder->Translate(-width + width/100.0f,0.0,0.0);
	triangle_box(meshbuilder1, width/100.0f,height,height);
	meshbuilder1->Scale(-1, -1,1);
	meshbuilder1->Translate(width/100.0f,0.0,0.0);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	meshbuilder->Translate(0.0,0.0,length /*-depth + 2.0f * height*/);
	meshbuilder->Translate(width - width/100,height,0.0);
	//glRotated(315.0f,1.0f,0.0,0.0);
	//box(meshbuilder, PI*3.0/4.0, width,sqrt(2.0) * height,width/100.0f);
	box(meshbuilder1, PI/4.0, width,width/100.0f,sqrt(2.0) * height);
	//meshbuilder1->Translate(0.0,depth - 2.0f * height,0.0);
	meshbuilder1->Translate(0.0,0.0,/*-depth + 2.0f * height*/length);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	
	meshbuilder1->Translate(0.0,0.0,/*depth - 2.0f * height*/ -length);
	meshbuilder1->Scale(-1,1, -1);
	meshbuilder1->Translate(width,0.0,0.0);
	hr = meshbuilder1->CreateMesh(&mesh);
	hr = meshbuilder->AddMesh(mesh);
	meshbuilder1->Empty(0);
	
	//glRotated(45.0f,1.0f,0.0,0.0);
	//box(meshbuilder1, PI/4.0, width,width/100.0f,sqrt(2.0) * height);
	
	//meshbuilder->Translate(0.0,-depth + 2.0f * height,0.0);
	box(meshbuilder, 0,0,0, width/100.0f,height,length/*2.0f * height- depth*/  );
	box(meshbuilder, 0,0,0, width,width/100.0f,length/*2.0f * height- depth*/);
	meshbuilder->Translate(-width + width/100.0f,0.0,0.0);
	box(meshbuilder, 0,0,0, width/100.0f,height,length /*2.0f * height- depth*/);
}

