#include "ConnectFour.h"
#include "ConnectProjectile.h"
#include "colors.h"
#include "rodcone.h"
#include "RubicsObjects.h"
#include "RubicsDirect3D.h"
#include <d3dtypes.h>
#include <stdlib.h>

CConnectProjectile::CConnectProjectile() {

  
}

D3DCOLOR CConnectProjectile::GetRandomColor(int color_choice) {
	switch(color_choice){
	case 0:
		if(rand() % 2)
			return RED;
		else return BLACK;
	case 1:
		if(rand() % 2)
			return REDO;
		else return ( D3DRGBA(0.0f, 0.0f, 0.0f, 90.0f) );
	default:
		if(rand() % 2)
			return RED;
		else return BLACK;
	}
}

CConnectProjectile::CConnectProjectile(LPDIRECT3DRM3 rm, LPDIRECT3DRMFRAME3 parent, Position* pos,
									   SoundSet *pSound, float rotation, D3DCOLOR color)
{
	LPDIRECT3DRMMESHBUILDER3 meshBuilder;
	LPDIRECT3DRMMESH		 mesh;
	parent_frame = parent;
	parent->AddRef();
	modified = FALSE;
	pSoundSet = pSound;
	bPlayedSound = FALSE;
	lpdsb = NULL;
	lpdsb3d = NULL;

	HRESULT hr;

	//Create the frame
	self_frame = NULL;
	//Setup defaults for the info. This will make the guy
	//stand still at the origin and do nothing.
	info = new rubiks_info;

	info->head  = 0.0f;
	info->pos = *pos;
	//info->pos.y = 0.0f;
	//info->pos.z = 0.0f;
	info->framecount = 0.0f;
	info->anim = STANDING;


	
	// Create the Mesh Builder for the Wagon
	if (FAILED( rm->CreateMeshBuilder( &meshBuilder ) ) )
	{
		DISPLAYMSG("Failed to Create Mesh Builder");
		goto error;
	}
	D3DVECTOR a,b;
	a.x = 0.0;
	a.y = 0.2f;
	a.z = 0.2f;

	b.x = 0.0;
	b.y = 0.0;
	b.z = 0.2f;
	
	//GetSquare(builder, 1.0f, color);
	//GetCylinder(builder, 0.3 ,0.5f, BLUE);
	AddRod(meshBuilder, 0.4f, a, b);
	Center(meshBuilder);
	
	if(color == RED){
		hr = meshBuilder->SetColor(GetRandomColor(1));
	}else{
		hr = meshBuilder->SetColor(GetRandomColor(0));
	}

	assert(!FAILED(hr));
	hr = meshBuilder->CreateMesh(&mesh);
	assert(!FAILED(hr));
	
	if( FAILED( rm->CreateFrame( parent, &self_frame) ) )
	{
		DISPLAYMSG( "Failed to create Projectile frame" );
		goto error;
	}

	if( FAILED( self_frame->AddVisual( mesh ) ) )
	{
		DISPLAYMSG( "Failed to add mesh builder to Projectile frame" );
		goto error;
	}

	if( FAILED( self_frame->SetRotation(NULL, 1.0f, 0.0f,0.0f,rotation) ) )
	{
		DISPLAYMSG( "Failed to add mesh builder to Projectile frame" );
		goto error;
	}

	if (FAILED(self_frame->SetPosition(parent, pos->x, pos->y, pos->z)))
				DISPLAYMSG("Error setting Position on Projectile");

	/*if (FAILED(self_frame->SetOrientation(parent, (cos(orientation)), 
										  0,
										  (sin(orientation)), 0, 1, 0)))
				DISPLAYMSG("Error setting Orientation on Non-Movable Object");*/
	
error:
	RELEASE( meshBuilder );
	RELEASE( mesh );
}


CConnectProjectile::~CConnectProjectile()
{	
	/* Frames */
	RELEASE(parent_frame);
	RELEASE(self_frame);

	/*Info*/
	delete info;
	info = NULL;
}

