#ifndef _RUBICSDIRECT3D_H__
#define _RUBICSDIRECT3D_H__

#include <windows.h>   // Standard Windows header file 
#include <direct.h>    // DirectDraw definitions 
#include <ddraw.h>
#include <dplay.h>    // DirectDraw definitions 
#include <d3drmwin.h>  // D3DRM definitions 

// Macro to release an object. 
#ifndef RELEASE
#define RELEASE(x) if (x != NULL) {x->Release(); x = NULL;}
#endif
 
// Macro to display a message box containing the given string. 
#ifndef DISPLAYMSG
//#define DISPLAYMSG(x) MessageBox(NULL, x, "Rubiks", MB_OK);
#define DISPLAYMSG(x) OutputDebugString(x)
#endif

// These 4 defined values set the parameters for our walls
#define DEFAULT_BOARD_Y 2
#define	WALL_HEIGHT 32
#define BOARD_X 512
#define BOARD_Y 512
#define PIECE_SIZE 4.0
#define DEFAULT_SPEED 0.5
#define DEFAULT_THETA 1.0
#define SPEED_FACTOR 100.0

#define BLACK  D3DRGB(0.0f, 0.0f, 0.0f)
#define RED	   D3DRGB(0.9f, 0.05f, 0.05f)
#define GREEN  D3DRGB(0.0f, 1.0f, 0.0f)
#define BLUE   D3DRGB(0.05f, 0.05f, 0.9f)
#define WHITE  D3DRGB(1.0f, 1.0f, 1.0f)
#define YELLOW D3DRGB(1.0f, 1.0f, 0.0f)
#define ORANGE D3DRGB(1.0f, 0.5f, 0.0f)
#define YELLOWO D3DRGBA(1.0f, 1.0f, 0.0f, 127.0f)
#define BLUEO  D3DRGBA(0.05f, 0.05f, 0.9f, 127.0f)
#define GREENO D3DRGBA(0.0f, 1.0f, 0.0f, 127.0f)
#define REDO   D3DRGBA(0.9f, 0.05f, 0.05f, 127.0f)



// Global Variables 
extern LPDIRECT3DRM3 lpD3DRM;
extern LPDIRECTDRAW4 lpDD;
extern LPDIRECTDRAWCLIPPER lpDDClipper;

extern HRESULT loadTexture(char *name, LPDIRECT3DRMTEXTURE3 *tex);

extern int PIECE_ID(short player, short object_num);
#endif //_RUBICSDIRECT3D_H_

void CenterBase(LPDIRECT3DRMMESHBUILDER3 builder);
void Center(LPDIRECT3DRMMESHBUILDER3 builder);
