#ifndef  __RUBIKS_ICONS__
#define  __RUBIKS_ICONS__
/**************************************************************************
 *
 * File:	RubicsIcons.h
 *
 * Author:	Grant Jorde
 *
 *************************************************************************/
#include <windows.h>   // Standard Windows header file 
#include <direct.h>    // DirectDraw definitions 
#include <d3drmwin.h>  // D3DRM definitions 
#include <ddraw.h>
#include <stdio.h>

#include "colors.h"
#include "rubiksInfo.h"
#include "client_objects.h"
#include "messages.h"
#include "RubiksSoundSet.h"
#include "SoundTypes.h"

#ifndef RELEASE
#define RELEASE(x) if (x != NULL) { x->Release(); x = NULL; } 
#endif

// Macro to display a message box containing the given string. 
#ifndef DISPLAYMSG
//#define DISPLAYMSG(x) MessageBox(NULL, x, "Rubiks ICON", MB_OK);
#define DISPLAYMSG(x) OutputDebugString(x)
#endif



class CIcons : public CClientObjects{

	public:
		CIcons( LPDIRECT3DRM3 lpD3DRM, LPDIRECT3DRMFRAME3 Parent, Position pos, float orientation, 
			    PieceType type, int rotation, SoundSet *pSS = NULL );	

		BOOL SetTextureToFace(int faceNumber, float fBlockSize,
		 					   LPDIRECT3DRMTEXTURE3 pTex, 
							   LPDIRECT3DRMMESHBUILDER3 mb );
		ScaleMe(float fx, float fy, float fz );

	private:
		// No private data needed on the client
protected:
	SoundSet * pSoundSet;
};

#endif //__RUBIKS_ICONS__
