/*
  *
  * RubiksWall.h  
  *
  *	
  * Author: Grant Jorde
  *
  */
#ifndef  __RUBIKS_WALL__
#define  __RUBIKS_WALL__

#include <windows.h>   // Standard Windows header file 
#include <direct.h>    // DirectDraw definitions 
#include <d3drmwin.h>  // D3DRM definitions 
#include <ddraw.h>
#include <stdio.h>
#include <math.h>

#include "colors.h"
#include "rubiksInfo.h"
#include "client_objects.h"
#include "messages.h"
#include "SoundTypes.h"
#include "RubiksSoundSet.h"

#ifndef RELEASE
#define RELEASE(x) if (x != NULL) { x->Release(); x = NULL; } 
#endif

// Macro to display a message box containing the given string. 
#ifndef DISPLAYMSG
//#define DISPLAYMSG(x) MessageBox(NULL, x, "Rubiks ICON", MB_OK);
#define DISPLAYMSG(x) OutputDebugString(x)
#endif


class RubicsWall : CClientObjectsNonMovable{

	public:
		RubicsWall( LPDIRECT3DRM3 lpD3DRM, 
					   LPDIRECT3DRMFRAME3 Parent, Position Pos, float orientation,
					   int wall_height, int wall_width, char* bmpFile, SoundSet *pSS = NULL );	
		~RubicsWall( );

		// Returns a frame that contains the Wall
		BOOL GetFrame( LPDIRECT3DRMFRAME3 *pFrame );

	protected:
		SoundSet *pSoundSet;
};

#endif //__RUBIKS_WALL__