#ifndef _DMUSIC_H_
#define _DMUSIC_H_

#include <windows.h>   // Standard Windows header file 
#include <direct.h>    // DirectDraw definitions 
#include <d3drmwin.h>  // D3DRM definitions 
#include <ddraw.h>
#include <stdio.h>
#include <dmusici.h>


class DMusic {

public:
	// needs to know the directory where the midi files are located
	// if Null is passed, current working directory is assumed

	DMusic(LPCSTR dir);
	~DMusic();
	// call this function to play a midi file
	// make sure that repeat is set TRUE -- play the file continuously
	//							or  FALSE -- play the file once
	// to load a new file, this function makes sure that this function
	// makes sure that current file is unloaded appropriately
	void PlayMidi(LPCSTR fileName, BOOL repeat);

	// call this function to stop 
	void StopMidi();
	
	void NextMidi();

	BOOL SetDirectory(LPCSTR dir);
private:
	// private functions
	void LoadMidi(LPCSTR  name);
	IDirectMusicPerformance* CreatePerformance(void);
	IDirectMusicLoader* CreateLoader(void);
	IDirectMusicSegment* LoadMIDISegment(WCHAR* wszMidiFileName );
	HRESULT FreeDirectMusic();

	// private variables
	IDirectMusicPerformance*             g_pPerf;
	IDirectMusicLoader*                  g_pLoader;
	IDirectMusicSegment*                 g_pMIDIseg ;
	IDirectMusicSegmentState*            g_pSegState;
	// the directory for the files
	WCHAR                                wszDir[_MAX_PATH];

	int                                   currentIndex; 

};

#endif
