/*==========================================================================
 *
 *  Copyright (C) 1996-1997 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       dpchat.h
 *  Content:	Header file for dpchat.cpp
 *
 ***************************************************************************/

#define IDIRECTPLAY2_OR_GREATER
#include <dplay.h>

// constants
const DWORD MAXPLAYERS = 10;			// max no. players in the session

// structure used to store DirectPlay information
typedef struct {

	LPDIRECTPLAY4A	lpDirectPlay4A;		// IDirectPlay4A interface pointer
	HANDLE			hPlayerEvent;		// player event to use
	DPID			dpidPlayer;			// ID of player created
	BOOL			bIsHost;			// TRUE if we are hosting the session
} DPLAYINFO, *LPDPLAYINFO;

// {96D360C0-F708-11d2-924C-00609776EA5F}
DEFINE_GUID(DPCHAT_GUID, 
0x96d360c0, 0xf708, 0x11d2, 0x92, 0x4c, 0x0, 0x60, 0x97, 0x76, 0xea, 0x5f);

/* OLD DPCHAT GUID don't use any more!
// guid for this application
// {5BFDB060-06A4-11d0-9C4F-00A0C905425E}
DEFINE_GUID(DPCHAT_GUID, 
0x5bfdb060, 0x6a4, 0x11d0, 0x9c, 0x4f, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);*/

// prototypes
extern HRESULT	ConnectUsingLobby(LPDPLAYINFO lpDPInfo);
extern HRESULT	ConnectUsingDialog(HINSTANCE hInstance, LPDPLAYINFO lpDPInfo);
extern void		ErrorBox(LPSTR lpszErrorStr, HRESULT hr);

const DWORD APPMSG_CHATSTRING	= 0;			// message type for chat string

// structures

// message structure used to send a chat string to another player
typedef struct {
	DWORD	dwType;								// message type (APPMSG_CHATSTRING)
	char	szMsg[1];							// message string (variable length)
} MSG_CHATSTRING, *LPMSG_CHATSTRING;

const UINT	WM_USER_ADDSTRING	= WM_USER+257;	// window message to add string to chat string list
const DWORD	MAXSTRLEN			= 200;			// max size of a temporary string

extern HWND	ghChatWnd;
extern void	HandleSystemMessage(LPDPLAYINFO lpDPInfo, LPDPMSG_GENERIC lpMsg, DWORD dwMsgSize,
									DPID idFrom, DPID idTo);
extern HRESULT SendChatMessage(HWND hWnd, LPDPLAYINFO lpDPInfo);
extern HRESULT NewChatString(LPDIRECTPLAY4A lpDirectPlay4A, DPID dpidPlayer,
							  LPSTR lpszMsg, LPSTR *lplpszStr);

