#include "overlay.h"
#include "RubicsDirect3D.h"
#include "ClientPlayer.h"
#include <string.h>
#include <stdlib.h>
#include <wingdi.h>
#include<Commctrl.h>


#define MAXMESSAGES 10
#define MAXCHARS    256

#define FONTSIZE   16
#define MAXPLAYERS 10
#define CUBESIZE   64
// spacing among the cubes

#define CUBESPACE				13
#define CUBEWIDTH				32
#define MYCUBEWIDTH				28
#define SPACE					3

#define ERED					0
#define EBLUE					1
#define EORANGE					2
#define EGREEN					3
#define EYELLOW					5
#define EWHITE					6
#define CRED					7
#define CBLUE					8
#define CORANGE					9
#define CGREEN					10
#define CYELLOW					12
#define CWHITE					13



// factor by which to scale down the position

#define SCALE					15
//#define 
// defining the image location inside the bitmap

// location of the Radar
#define RADTOPX					0
#define RADTOPY					70
#define RADBOTX					90
#define RADBOTY					159


// location of the chain
#define LTOPX					0
#define LTOPY					2
#define LBOTX					220
#define LBOTY					11

// location of the squares
#define SQTOPX					0
#define SQTOPY					14
#define SQWIDTH					16

// location fo the marbles
#define MRTOPX					0
#define MRTOPY					33
#define MRWIDTH					9
// location of the box to hold the cubes
#define BOXTOPX					0
#define BOXTOPY					46
#define BOXBOTX					99
#define BOXBOTY					64

// location of the weapon bitmaps on the whole bitmap
#define WPTOPX					0
#define WPTOPY					163
#define WPLENGTH				24
#define WPWIDTH					18

// location of the health bar on the whole bitmap
#define HEALTHBARTOPX			1
#define HEALTHBARTOPY			186
#define HEALTHBARLENGTH			200
#define HEALTHBARWIDTH			25

// for the health bar frame
#define FRAMETOPX				1
#define FRAMETOPY				222
#define FRAMEBOTY				269
#define FRAMEBOTX				292

// all these information for displaying in the client window
#define STWIDTH					2
#define STLENGTH				100

// applies for full window mode
//upper left corners for cubes to be displayed
#define TEAM1LEFTX				400
#define  SQLEFTY				1
#define TEAM2LEFTX				5

#define STLEFTX					400
#define STLEFTY					400


// position on the screen for the radar
#define RADLEFTX				250
#define RADLEFTY				(HEALTHBARWIDTH/2) + (CUBEWIDTH/2)+SPACE
#define RADCENTX				RADLEFTX+ 44
#define RADCENTY				RADLEFTY+43
#define LWIDTH					5
#define LLENGTH					(SQWIDTH)*6 + 5 * CUBESPACE

#define FRAMELENGTH				MAXHEALTH+2
#define FRAMEWIDTH				(HEALTHBARWIDTH/2)+3

#define WEAPONHEIGHT			(CUBEWIDTH/2) + SPACE
#define WEAPONWIDTH				(CUBEWIDTH/2) + SPACE+1

// position of the health bar on the screen
#define HEALTHLEFTX				250
#define HEALTHLEFTY				4

// max health value
#define MAXHEALTH				100
// starting position on the screen for my stat

#define MYPOSX					0
#define MYPOSY					0
// to scale the size of the objects
float scaleFact;
PieceID id = 0;
PieceType piece = NONE;
int endTeam = -1;
int fireworks = 0;
int currentIndex = 1;
char player1Name[16];
char player2Name[16];

COLORREF team1Col = RGB(255,0,0);
COLORREF team2Col = RGB(0,0,255);



typedef struct pos_ {
	D3DVALUE x;
	D3DVALUE y;
} myVector;

Overlay::Overlay(IDirectDraw4* pd,LPDIRECTDRAWSURFACE4 lpddsPrimary, HWND hw) {
	// initialize all the private variables
	

	ovhWnd = hw;
	ovSurface = lpddsPrimary;
	pdd = pd;

	
	pdds			= NULL;
	endScreen		= NULL;
	tornado			= NULL;
	oneShot			= NULL;
	threeShot		= NULL;
	oneShotChecker	= NULL;
	threeShotChecker= NULL;
	ram				= NULL;
	threeAndRico = NULL;
	threeRicoChecker = NULL;
	ricochet = NULL;
	mortar = NULL;
	hoaming = NULL;
	mortarChecker = NULL;
	evil  = NULL;
	reallyEvil = NULL;
	if(lpddsPrimary == NULL) {
		FreeObjects();
		return;

	}
	fontSize = 11;
	turn = false;
	//health = MAXHEALTH;


	drawEndingOverlay = FALSE;
	// for displaying our game message 

	
	time(&prevTime);


	
	//load the bitmap for overlays
	pdds		= LoadBitmap("status.bmp");
	//endScreen = LoadBitmap("WinningScreen.bmp");
	tornado		= LoadBitmap("tornado.bmp");
	memcpy(&tornadoRect,&endScreenRect,sizeof(endScreenRect));
	oneShot		= LoadBitmap("1shot.bmp");
	memcpy(&oneShotRect,&endScreenRect,sizeof(endScreenRect));
	threeShot	= LoadBitmap("3shot.bmp");
	memcpy(&threeShotRect,&endScreenRect,sizeof(endScreenRect));

	oneShotChecker		= LoadBitmap("1shot_checker.bmp");
	memcpy(&oneCheckerRect,&endScreenRect,sizeof(endScreenRect));
	
	threeShotChecker	= LoadBitmap("3shot_checker.bmp");
	memcpy(&threeCheckerRect,&endScreenRect,sizeof(endScreenRect));
	
	ram		= LoadBitmap("ram.bmp");
	memcpy(&ramRect,&endScreenRect,sizeof(endScreenRect));
	
	threeAndRico = LoadBitmap("3shotAndRic.bmp");
	memcpy(&threeAndRicoRect,&endScreenRect,sizeof(endScreenRect));
	
	threeRicoChecker = LoadBitmap("3shot_checkerAndRic.bmp");
	memcpy(&threeRicoCheckerRect,&endScreenRect,sizeof(endScreenRect));
	
	ricochet = LoadBitmap("Ricochet.bmp");
	memcpy(&ricochetRect,&endScreenRect,sizeof(endScreenRect));

	mortar = LoadBitmap("mortar.bmp");
	memcpy(&mortarRect,&endScreenRect,sizeof(endScreenRect));

	hoaming = LoadBitmap("missile.bmp");
	memcpy(&hoamingRect,&endScreenRect,sizeof(endScreenRect));

	mortarChecker = LoadBitmap("mortar_checker.bmp");
	memcpy(&mortarCheckerRect,&endScreenRect,sizeof(endScreenRect));

	evil = LoadBitmap("Evil.bmp");
	memcpy(&evilRect,&endScreenRect,sizeof(endScreenRect));

	reallyEvil = LoadBitmap("ReallyEvil.bmp");
	memcpy(&reallyEvilRect,&endScreenRect,sizeof(endScreenRect));
	

	
	if(pdds)
		SetColorKey(pdds,RGB(255, 255, 255));
	if(tornado)
		SetColorKey(tornado,RGB(255, 255, 255));
	if(oneShot)
		SetColorKey(oneShot,RGB(255, 255, 255));
	if(threeShot)
		SetColorKey(threeShot,RGB(255, 255, 255));
	if(oneShotChecker)
		SetColorKey(oneShotChecker,RGB(255, 255, 255));
	if(threeShotChecker)
		SetColorKey(threeShotChecker,RGB(255, 255, 255));
	if(ram)
		SetColorKey(ram,RGB(255, 255, 255));
	if(threeAndRico)
		SetColorKey(threeAndRico,RGB(255,255,255));
	if(threeRicoChecker)
		SetColorKey(threeRicoChecker,RGB(255,255,255));
	if(ricochet)
		SetColorKey(ricochet,RGB(255,255,255));
	if(mortar)
		SetColorKey(mortar,RGB(255,255,255));
	if(hoaming)
		SetColorKey(hoaming,RGB(255,255,255));
	if(mortarChecker)
		SetColorKey(mortarChecker,RGB(255,255,255));
	if(evil)
		SetColorKey(evil,RGB(0,0,0));
	if(reallyEvil)
		SetColorKey(reallyEvil,RGB(0,0,0));
	
	SetFont(FONTSIZE,FW_NORMAL);

}
void
Overlay::FreeObjects() {

	
	if(pdds) {
		pdds->Release();
		pdds = NULL;
	}
	if(endScreen){
		endScreen->Release();
		endScreen = NULL;

	}
	if(tornado){
		tornado->Release();
		tornado = NULL;

	}
	if(oneShot) {
		oneShot->Release();
		oneShot = NULL;


	}

	if(threeShot) {

		threeShot->Release();
		threeShot = NULL;

	}
	RELEASE(threeAndRico);
	RELEASE(threeRicoChecker);
	RELEASE(ricochet);
	RELEASE(mortar);
	RELEASE(hoaming);
	RELEASE(mortarChecker);
	RELEASE(evil);
	RELEASE(reallyEvil);
	



}

Overlay::~Overlay(){

	FreeObjects();
}


IDirectDrawSurface4*
Overlay::LoadBitmap(LPCSTR szBitmap)
{	HBITMAP                 hbm;
    
    BITMAP                  bm;
	DDSURFACEDESC2          ddsd;
	IDirectDrawSurface4     *surface;
	//IDirectDrawSurface4    *pdds;
    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, 0,
                              0, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, 0, 0,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)

        return NULL;
    //
    // Get size of the bitmap

	GetObject(hbm, sizeof(bm), &bm);
    //
    // Create a DirectDrawSurface for this bitmap
    //
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = bm.bmWidth;
    ddsd.dwHeight = bm.bmHeight;
    if (pdd->CreateSurface(&ddsd, &surface, NULL) != DD_OK)
        return NULL;
    if(CopyBitmap( surface,hbm,0, 0,0,0) == -1)
		return NULL;
    
    return surface;
}

HRESULT
Overlay::ReLoadBitmap(IDirectDrawSurface4 * pdds, LPCSTR szBitmap)
{
    HBITMAP                 hbm;
    HRESULT                 hr;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, 0,
                              0, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, 0, 0,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
    {
        OutputDebugString("handle is null\n");
        return E_FAIL;
    }
    hr = CopyBitmap(pdds, hbm, 0, 0, 0, 0);
    if (hr != DD_OK)
    {
        OutputDebugString("ddcopybitmap failed\n");
    }
    DeleteObject(hbm);
    return hr;
}
void
Overlay::RestoreAll() {

	ReLoadBitmap(pdds,"status.bmp");
	ReLoadBitmap(tornado,"tornado.bmp");
	memcpy(&tornadoRect,&endScreenRect,sizeof(endScreenRect));
	ReLoadBitmap(oneShot,"1shot.bmp");
	memcpy(&oneShotRect,&endScreenRect,sizeof(endScreenRect));
	ReLoadBitmap(threeShot,"3shot.bmp");
	memcpy(&threeShotRect,&endScreenRect,sizeof(endScreenRect));

	ReLoadBitmap(oneShotChecker,"1shot_checker.bmp");
	memcpy(&oneCheckerRect,&endScreenRect,sizeof(endScreenRect));
	
	ReLoadBitmap(threeShotChecker,"3shot_checker.bmp");
	memcpy(&threeCheckerRect,&endScreenRect,sizeof(endScreenRect));
	
	ReLoadBitmap(ram,"ram.bmp");
	memcpy(&ramRect,&endScreenRect,sizeof(endScreenRect));
	
	ReLoadBitmap(threeAndRico,"3shotAndRic.bmp");
	memcpy(&threeAndRicoRect,&endScreenRect,sizeof(endScreenRect));
	
	ReLoadBitmap(threeRicoChecker,"3shot_checkerAndRic.bmp");
	memcpy(&threeRicoCheckerRect,&endScreenRect,sizeof(endScreenRect));
	
	ReLoadBitmap(ricochet,"Ricochet.bmp");
	memcpy(&ricochetRect,&endScreenRect,sizeof(endScreenRect));

	ReLoadBitmap(mortar,"mortar.bmp");
	memcpy(&mortarRect,&endScreenRect,sizeof(endScreenRect));

	ReLoadBitmap(hoaming,"missile.bmp");
	memcpy(&hoamingRect,&endScreenRect,sizeof(endScreenRect));

	ReLoadBitmap(mortarChecker,"mortar_checker.bmp");
	memcpy(&mortarCheckerRect,&endScreenRect,sizeof(endScreenRect));

	ReLoadBitmap(evil,"Evil.bmp");
	memcpy(&evilRect,&endScreenRect,sizeof(endScreenRect));

	ReLoadBitmap(reallyEvil,"ReallyEvil.bmp");
	memcpy(&reallyEvilRect,&endScreenRect,sizeof(endScreenRect));



}
int
Overlay::CopyBitmap(IDirectDrawSurface4 *surface,HBITMAP hbm,int x, int y,int dx, int dy)
{
	HDC                     hdcImage;
    HDC                     hdc;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hr;

    if (hbm == NULL || surface == NULL)
        return -1;
    //
    // Make sure this surface is restored.
    //
    surface->Restore();
    //
    // Select bitmap into a memoryDC so we can use it.
    //
    hdcImage = CreateCompatibleDC(NULL);
    if (!hdcImage)
        OutputDebugString("createcompatible dc failed\n");
    SelectObject(hdcImage, hbm);
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    dx = dx == 0 ? bm.bmWidth : dx;     // Use the passed size, unless zero
    dy = dy == 0 ? bm.bmHeight : dy;
    //
    // Get size of surface.
    //
	endScreenRect.top = 0;
	endScreenRect.left = 0;
	endScreenRect.bottom = bm.bmHeight;
	endScreenRect.right = bm.bmWidth;

    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH;
    surface->GetSurfaceDesc(&ddsd);

    if ((hr = surface->GetDC(&hdc)) == DD_OK)
    {
        StretchBlt(hdc, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hdcImage, x, y,
                   dx, dy, SRCCOPY);
        surface->ReleaseDC(hdc);
    }
    DeleteDC(hdcImage);
    return hr;
}


void Overlay::SetFont(int size,DWORD weight) {

	textFont = CreateFont(size,
                         0, 0, 0, FW_EXTRABOLD, FALSE, FALSE, FALSE,
                         ANSI_CHARSET,
                         OUT_RASTER_PRECIS,
                         CLIP_DEFAULT_PRECIS,
                         DEFAULT_QUALITY,
                         VARIABLE_PITCH,
                         "Book Antiqua");


}
int
Overlay::PrintMessage(char* msg, int x, int y,COLORREF col,BOOL bg) {

	HDC hdc;
	if (ovSurface ==NULL) 
		hdc = GetDC(ovhWnd);
	else 
		if ((ovSurface->GetDC(&hdc)	) != DD_OK)
			return 0;

		
		SelectObject(hdc,textFont);
		//bk = GetBkColor(hdc);
		if(bg)
			SetBkColor(hdc,RGB(0,0,0));
			
		else
			SetBkMode(hdc,TRANSPARENT);
		//SetBkColor(hdc,RGB(0,100,100));
		//SetTextAlign(hdc,TA_CENTER);
		SetTextColor(hdc,col);
		
		//TextOut(hdc,x,y, msg, strlen(msg));
		ExtTextOut(hdc,x,y,ETO_OPAQUE,NULL,msg,strlen(msg),NULL);
		if (ovSurface !=NULL )
			ovSurface->ReleaseDC(hdc);
		else ReleaseDC(ovhWnd, hdc);

	return 0;
}
void
Overlay::InitEndingOverlay(PieceID id,int team,PieceType piece,BOOL won) {

	drawEndingOverlay = won;
	id = id;
	endTeam = team;
	piece = piece;


}

void
Overlay::SetMessageIndex(char* name1,char*name2,int index) {
	

	currentIndex = index;
	strcpy(player1Name,name1);
	strcpy(player2Name,name2);
	time(&prevTime);

}
void
Overlay::DisplayMessage() {
  
	if(!ovSurface) return;

	time_t currentTime;
	time(&currentTime);

	char* msg =NULL ;
	char message[256];
	message[0] = '\0';


	BOOL printName1, printName2, switch_names = FALSE;

	long   x = 4, y = 450;
	printName1 = TRUE; printName2 = TRUE;
	
	// don't display after 10 seconds have elapsed
	if((currentTime - prevTime) <= 15 ) {

	
		switch(currentIndex) {
	  
		case 1:
		msg = "Let the games begin!!!";
		printName1 = false; printName2 = false;
		break;
		case 2:
		msg = "just blew away a piece off of";
		break;
		case 3:
		msg = "got the pieces rammed out of 'em courtesy of";
		switch_names = TRUE;
		break;
		case 4:
		msg = "unleashes some tornado fury on";
		break;
		case 5:
		msg = "can't escape the wrath of";
		switch_names = TRUE;
		break;
		case 6:
		msg = "shoots away another piece from";
		break;
		case 7:
		msg = "lets some spinning connect-4 madness go on";
		break;
		case 8:
		msg = "unloads an evil attack on";
		break;
		case 9:
		msg = "gets embarrassed at the hands of";
		switch_names = TRUE;
		break;
		case 10:
		msg = "leaves the game like a little coward";
		printName1 = false;
		switch_names = TRUE;
		break;
		default:
		msg = "Yeah baby, Yeah! This rocks!";
		printName1 = false; printName2 = false;
		break;
		}

		/*ovSurface->GetDC(&hdc);
			 GetTextExtentPoint32(hdc,msg,strlen(msg),&size1);
			 if(player1Name && printName1)
				GetTextExtentPoint32(hdc,player1Name,strlen(player1Name),&size2);
			 if(player2Name && printName2)
				GetTextExtentPoint32(hdc,player2Name,strlen(player2Name),&size3);
			 ovSurface->ReleaseDC(hdc);*/

		if(!switch_names){
			 if(player1Name && printName1){
				//PrintMessage(player1Name,x,y,team1Col,false);
				//x = x + size2.cx + 2*SPACE;
				//x = x + size2.cx - SPACE;
				strcat(message,player1Name);
				strcat(message," ");
			  }
			  if(msg){
				//PrintMessage(msg,x,y,team2Col,false);
				//x = x + size1.cx + 3*SPACE;
				strcat(message,msg);
				strcat(message," ");
				  //x = x + size1.cx - 11*SPACE;
			  }
			  if(player2Name && printName2){
				 strcat(message,player2Name);
				strcat(message," ");
				//PrintMessage(player2Name,x,y,team1Col,false);
			  }
		}else{
			 if(player2Name && printName2){
				strcat(message,player2Name);
				strcat(message," ");
				//PrintMessage(player2Name,x,y,team1Col,false);
				//x = x + size3.cx + 2*SPACE;
				//x = x + size3.cx - SPACE;
			 }
			 if(msg){
				strcat(message,msg);
				strcat(message," ");
				//PrintMessage(msg,x,y,team2Col,false);
				 // x = x + size1.cx + 3*SPACE;
				  //x = x + size1.cx - 11*SPACE;
			 }
			 if(player1Name && printName1){
				strcat(message,player1Name);
				strcat(message," ");
				//PrintMessage(player1Name,x,y,team1Col,false);
			 }
		}
		PrintMessage(message,x,y,team1Col,false);
	}
	
}

void
Overlay::DisplayEndingOverlay(int myTeam) {
	HRESULT hr;
	char temp[30];
	char num[10];
	temp[0] = '\0';
	if (myTeam == endTeam || myTeam == 3) {
			if(endScreen)
				endScreen->Release();
			endScreen = LoadBitmap("WinningScreen.bmp");
		
	}
	else 
		endScreen = LoadBitmap("LosingScreen.bmp");

	if(endScreen){
			SetColorKey(endScreen,RGB(255,255,255));
			hr = ovSurface->BltFast(50, 50, endScreen,
                                  &endScreenRect, DDBLTFAST_SRCCOLORKEY);
		
	}
	
	if(endScreen)
		endScreen->Release();
	strcat(temp,"fireworks");
	_itoa(fireworks,num,10);
	strcat(temp,num);
	strcat(temp,".bmp");
	
	endScreen = LoadBitmap(temp);
	fireworks = (fireworks +1)%15;
	
	if(endScreen){
		SetColorKey(endScreen,RGB(0,0,0));
		hr = ovSurface->BltFast(50, 50, endScreen,
                                 &endScreenRect, DDBLTFAST_SRCCOLORKEY);
		
	}
	PrintMessage("PLEASE WAIT..LOADING...",0,450,RGB(255,0,255),TRUE);
}



int 
Overlay::GetCubeFrame(PieceType type, int index){

	if(type != NONE) {
		if (type == RED_RUBIKS_PIECE) {
					
			return CRED;		

		} else if (type ==BLUE_RUBIKS_PIECE) {
			return CBLUE;		
				

		} else if (type == YELLOW_RUBIKS_PIECE) {
					
			return CYELLOW;		


		}else if (type == WHITE_RUBIKS_PIECE) {

			return CWHITE;		
				
		} else if (type == ORANGE_RUBIKS_PIECE) {
			return CORANGE;
					
			
		} else if (type == GREEN_RUBIKS_PIECE) {
				
			return CGREEN;	

		} 
	}

	switch(index) {
	case 0:
		return ERED;
	case 1:
		return EGREEN;
	case 2:
		return EORANGE;
	case 3:
		return EBLUE;
	case 4:
		return EYELLOW;
	case 5:
		return EWHITE;
	default:
		return -1;

	}


}


void
Overlay::DrawRadar(PieceID myID,ObjectMap &mapPieces) {

	if(!ovSurface)
		return;
	int frame;
	DoBlt(RADAR,0,RADLEFTX,RADLEFTY,FALSE);
	D3DVALUE      head;
	myVector      hisPos, myPos;
	CClientPlayer* moa;
	int           team;
	// calculate the position of the other players
	ObjectMap::iterator it;
	it = mapPieces.find(myID);
	if (it != mapPieces.end()){
		CClientObjects * obj =it->second;
		moa = ((CClientPlayer*)(it->second));
		head = (moa->GetInfo())->head;
		myPos.x = (moa->GetInfo())->pos.x;
		myPos.y = (moa->GetInfo())->pos.z;
		currentWeapon = moa->GetCurrentWeapon();
		
		for(it = mapPieces.begin(); it != mapPieces.end(); it++){
			

			if(it->second->IsPlayer() || it->second->IsRubiksPiece()){
				
				hisPos.x = (it->second->GetInfo())->pos.x;
				hisPos.y = (it->second->GetInfo())->pos.z;
				//hisPos.x = 0; hisPos.y = 400;
				if(CalcPos(&hisPos,&myPos,head)){
				if(it->second->IsPlayer()){
					team = ((CClientPlayer*)(it->second))->GetTeam();
					if( team != 3){
						
							if(myID == it->first){
								if(team == 1) frame = 1;
								else frame = 3;
								PutObjectsInRadar(MARBLE,frame, RADCENTX-(int)hisPos.x, RADCENTY-(int)hisPos.y,false,team);

							}
						else 
							PutObjectsInRadar(MARBLE,0, RADCENTX-(int)hisPos.x, RADCENTY-(int)hisPos.y,true,team);
					}
				}
		
				else 
					if (it->second->IsRubiksPiece()){
						frame = GetCubeFrame(it->second->GetType(),-1);
				
						if (frame >= 0){
					
							PutObjectsInRadar(CUBEICON,frame, RADCENTX-(int)hisPos.x, RADCENTY-(int)hisPos.y,TRUE,-1);
			
						}
					}
				}
			}
		
		}
		if (turn) turn = false;
		else turn = true;

	}


}

// puts the new calculated position into hisPos
BOOL
Overlay::CalcPos(myVector* hisPos, myVector* myPos, D3DVALUE head){
	float diff;
	scaleFact = 3.0;
	float dist, theta1, thetaDiff;
	hisPos->x = (hisPos->x - myPos->x)/ (float) SCALE;
	hisPos->y = (hisPos->y - myPos->y)/ (float) SCALE;
	
	// get the distance
	dist = sqrt(pow(hisPos->x,2)+pow(hisPos->y,2));
	if(dist > 39)
		return false;
	if(dist > 7) {
		
		diff = dist - 7.0;
		scaleFact = scaleFact -  ( diff / 40.0);
		if(scaleFact <= 0.0 ) scaleFact = 1.0; 


	}
	else {

		if (scaleFact < 3) {
			diff = 7.0 - dist;
			scaleFact = scaleFact + (diff / 40.0);
			if(scaleFact > 3) scaleFact = 3;

		}


	}
	// calculate the angle
	theta1 = atan2(hisPos->x,hisPos->y);
	// get the difference
	thetaDiff = head - theta1;
	// now calculate the new position
	hisPos->x = cos(thetaDiff)*dist;
	hisPos->y = -sin(thetaDiff)* dist;
	return true;

}
void
Overlay::PutObjectsInRadar(BTYPE type,int frame, int x, int y,BOOL blink, int team) {
	
	int px = 100;

	switch (type) {
	case MARBLE:
		if(blink) {
			if (team == 1) {
				if(turn)
					frame = 0;
				else frame = 1;
			}
			else {

				if(turn)
					frame = 2;
				else frame = 3;


			}
		}
		DoBlt(type,frame,x,y,FALSE);
		
		break;
	case CUBEICON:
		DoBlt(type,frame,x,y,FALSE);
		break;
	default:
		break;
	}


}
void
Overlay::DrawAllPlayersStat(ObjectMap &mapPieces,PieceID myID) {
	//Grant hacked this to display the teams in 2 columns see comments below
	int            x,y,team1x,team1y,team2x,team2y,tempx, frame,team;
	SIZE            size;
	HDC             hdc;
	BOOL            empty1, empty2,first;
	COLORREF        col;
	RECT            destRect;
	DDBLTFX			  ddbltfx;
	ddbltfx.dwSize  =	  sizeof(ddbltfx);
	DWORD bltFlags		  =	  DDBLT_KEYSRC;
	HRESULT         hr;
	if (ovSurface == NULL)
		return;
	PieceID playerID;
	CClientPlayer* moa, *current;
	empty1 = TRUE;
	empty2 = TRUE;
	

	
	

	ovSurface->GetDC(&hdc);
	//hdc = GetDC(ovhWnd);
	GetTextExtentPoint32(hdc,"PLAYERALL ", strlen("PLAYERALL  :"),&size);
	ovSurface->ReleaseDC(hdc);
	//ReleaseDC(ovhWnd,hdc);
	
	
	team1x = TEAM1LEFTX;
	team1y = SQLEFTY;

	team2x = TEAM2LEFTX;
	team2y = SQLEFTY;

	// i HAVE NOT BEEN DRAWn yet
	first = FALSE;

	PieceType type;
	ObjectMap::iterator it;
	moa = NULL;
	it = mapPieces.find(myID);
	if(it !=mapPieces.end()) {
		moa = ((CClientPlayer*)(it->second));
		team = moa->GetTeam();
		if( team!= 3) {
			// always print the team I am in on the left
			if(team == 1) {
				team1x = TEAM2LEFTX;
				team2x = TEAM1LEFTX;

			}


		}



	}

	// Draw the boundary around
	//PrintMessage("Evil Team",team1x, team1y,team1Col,TRUE);
	
	destRect.left = team1x;
	destRect.top = team1y;
	destRect.bottom = team1y+10;
	destRect.right  = team1x+6 * (CUBEWIDTH)- CUBESPACE/2;
	if(evil){
		hr = ovSurface->Blt(&destRect, evil, &evilRect, 
						bltFlags, &ddbltfx);
		//PrintMessage("Evil Team",team1x, team1y,team1Col,TRUE);
	}
	team1y +=15;

	// team2's title postion
	destRect.left = team2x;
	destRect.top = team2y;
	destRect.bottom = team2y+15;
	destRect.right  = team2x+6 * (CUBEWIDTH)- CUBESPACE/2;
	DoBlt(BOUNDARY,0,team1x,team1y,FALSE);
	//PrintMessage("Really Evil Team",team2x, team2y,team2Col,TRUE);
	if(reallyEvil) {
			hr= ovSurface->Blt(&destRect, reallyEvil, &reallyEvilRect, 
						bltFlags, &ddbltfx);


	}
	team2y +=15;
	DoBlt(BOUNDARY,0,team2x,team2y,FALSE);
	team1y = team1y + LWIDTH + SPACE + SPACE/2;
	team2y = team2y + LWIDTH + SPACE + SPACE/2;
	
	for(it = mapPieces.begin(); it != mapPieces.end(); it++){
		current = ((CClientPlayer*)(it->second));
		// draw me first
		playerID = it->first;
		if(first && myID == it->first) continue;
		
		if(!first && myID == it->first) {

			first = TRUE;
			it = mapPieces.begin();
		}
		if( first && current->IsPlayer() && current->GetTeam() != 3 ){
			//Grant separated the teams blocks at different column widths
			//I use teamx to figure out the x coordinate for each team
			//I use team1y & team2y to figure out the y coord for each team
			if(current->GetTeam() == 2){
				y = team2y;
				x = team2x;
				empty2 = FALSE;
				col = team2Col;
			}else{
				y = team1y;
				x = team1x;
				empty1 = FALSE;
				col = team1Col;
			}
			//tempx = x;
		    tempx = x;

			// Print all player's login names on the right of the screen
			if(current->name != NULL){
			
				PrintMessage(current->name,x,y,col,false);

			}
			else
				PrintMessage("Player :",x,y,col,false);
			// shifted over a bit to make room for 9 char names
			tempx = tempx + (size.cx) /2 + 7*SPACE ;
			DoBlt(BOX,0,tempx,y,FALSE);
			
			for (int j = 0; j < 6;  j ++) {
				
				type = current->GetCenterCube(j);
				frame = GetCubeFrame(type,j);
				if (frame >= 0 ){
					 DoBlt(CUBE,frame,tempx,y,FALSE);
					tempx = tempx + CUBEWIDTH/2 + SPACE;
				}
			}
		
			// if it is me, print my stuff on the my right side

			if (moa !=NULL && myID == playerID) {
				tempx = tempx + 2* SPACE;
			
				DrawWeapon(moa,tempx,y);

			}
		//x = tempx;
		if(current->GetTeam() == 2)
			team2y = team2y + CUBEWIDTH/2+ 3*SPACE;
		else
			team1y = team1y + CUBEWIDTH/2+ 3*SPACE;


		}
	}
	// print the message if the team has no players
	if(empty1){
		PrintMessage("No players joined this team.",team1x,team1y,team1Col,false);
		team1y += size.cy;

	}
	if(empty2) {

		PrintMessage("No players joined this team.",team2x,team2y,team2Col,false);
		team2y += size.cy;


	}
	DoBlt(BOUNDARY,0,team1x,team1y,FALSE);
	DoBlt(BOUNDARY,0,team2x,team2y,FALSE);


}

void
Overlay::DrawWeapon(CClientPlayer* player, int &tempx, int &y) {

  HRESULT			  hr;
  DDBLTFX			  ddbltfx;
  DWORD				  bltFlags;
  RECT				  destRect; // unreferenced: srcRect;
  ddbltfx.dwSize  =	  sizeof(ddbltfx);
  bltFlags		  =	  DDBLT_KEYSRC;
  BOOL				  connectFour = FALSE;
  // unreferenced: IDirectDrawSurface4*  temp;
  // unreferenced:RECT                  tempRect;
  COLORREF            col;

  
  if (player->GetType() == CONNECT_FOUR) {
	 connectFour = TRUE;
  }

  if(player->GetTeam() == 1)
	col = team1Col;
  else 
	col = team2Col;
  	// take care of the special weapon
	destRect.left = tempx- SPACE; destRect.top = y - SPACE;
	destRect.right = tempx + WEAPONWIDTH;
	destRect.bottom = y + WEAPONHEIGHT;

	if (!player->IsMultiShot() && !player->IsRicochete()){
				
	  if(connectFour){
		if(oneShotChecker){
			hr = ovSurface->Blt(&destRect, oneShotChecker, &oneCheckerRect, 
						bltFlags, &ddbltfx);
			tempx = tempx + WEAPONWIDTH + SPACE;
			
		}
	  }
	  else {
		if(oneShot){
		  hr = ovSurface->Blt(&destRect, oneShot, &oneShotRect, 
						bltFlags, &ddbltfx);
		  tempx = tempx + WEAPONWIDTH + SPACE;
		  
		}
	  }
	
		
	}

		else
			if(player->IsMultiShot() && player->IsRicochete()) {
					// display dummy bitmap
			  if(connectFour){
				if(threeRicoChecker) {
				   hr = ovSurface->Blt(&destRect, threeRicoChecker, &threeRicoCheckerRect, 
						bltFlags, &ddbltfx);
				   tempx = tempx + WEAPONWIDTH + SPACE;
				}
			  }
			  else {
				if(threeAndRico) {
				  hr = ovSurface->Blt(&destRect, threeAndRico, &threeAndRicoRect, 
						bltFlags, &ddbltfx);
				
				  tempx = tempx + WEAPONWIDTH + SPACE;
				}
			  }
				
			}
			else
				if(player->IsMultiShot()) {
					

				  if(connectFour){
					if(threeShotChecker){
					  	hr = ovSurface->Blt(&destRect, threeShotChecker, &threeCheckerRect, 
								bltFlags, &ddbltfx);
						tempx = tempx + WEAPONWIDTH + SPACE;
						
					}
				  }
				  else {
					if(threeShot){
					  
					  hr = ovSurface->Blt(&destRect, threeShot, &threeShotRect, 
								bltFlags, &ddbltfx);
					  tempx = tempx + WEAPONWIDTH + SPACE;
					  
					}
					
				  }
				}
				else{
				  if(ricochet) {
					hr = ovSurface->Blt(&destRect, ricochet, &ricochetRect, 
								bltFlags, &ddbltfx);
					tempx = tempx + WEAPONWIDTH + SPACE;
					
				  }
					
				}

	tempx = tempx +  SPACE;
	destRect.left = tempx - SPACE; destRect.top = y - SPACE;
	destRect.right = tempx + WEAPONWIDTH;
	destRect.bottom = y + WEAPONHEIGHT;

	currentWeapon = player->GetCurrentWeapon();
	switch(currentWeapon) {
	case Stomp:
	  
	  break;
	case Tornado:
		if(connectFour) {
			if(hoaming) {

				hr = ovSurface->Blt(&destRect, hoaming, &hoamingRect, 
								bltFlags, &ddbltfx);
				tempx = tempx + WEAPONWIDTH + SPACE;

			}


		}
		else

			if(tornado) {
				hr = ovSurface->Blt(&destRect, tornado, &tornadoRect, 
								bltFlags, &ddbltfx);
				tempx = tempx + WEAPONWIDTH + SPACE;
		
		 }
	  break;
	case Ram:
	  if(ram) {
		hr = ovSurface->Blt(&destRect, ram, &ramRect, 
								bltFlags, &ddbltfx);
		tempx = tempx + WEAPONWIDTH + SPACE;
		
	  }
	  break;
	case ArcingMortar:
		if(connectFour) {
			
			if(mortarChecker) {
				
				hr = ovSurface->Blt(&destRect, mortarChecker, &mortarCheckerRect, 
								bltFlags, &ddbltfx);
				tempx = tempx + WEAPONWIDTH + SPACE;
			}
		
	  }
		else
			if(mortar){
				hr = ovSurface->Blt(&destRect, mortar, &mortarRect, 
								bltFlags, &ddbltfx);
				tempx = tempx + WEAPONWIDTH + SPACE;
			
			}


		
	  break;

	default:
		break;
	}
 
	if(hr == DDERR_SURFACELOST){
				RestoreAll();
			
	}			

}

void
Overlay::DrawMyStat(ObjectMap &mapPieces,PieceID myID){

	// currently only displays the health bar

	if (ovSurface == NULL)
		return;
	SIZE size;
	HDC hdc;
	float myHealth;
	//unreferenced:  char msg[10];
	ovSurface->GetDC(&hdc);
	GetTextExtentPoint32(hdc,"66%", strlen("66%"),&size);
	ovSurface->ReleaseDC(hdc);

	ObjectMap::iterator it;
	it = mapPieces.find(myID);
	if(it != mapPieces.end()) {
		if(((CClientPlayer*)(it->second))->GetTeam() != 3) {
			DoBlt(FRAME,0,HEALTHLEFTX,HEALTHLEFTY +size.cy,FALSE);
			myHealth = (float)(((CClientPlayer*)(it->second))->getHitpoints());
			myHealth = myHealth / 150.00;
			health = (int) ((float) 100 * myHealth);
			//_itoa(health,msg,10);
			//strcat(msg,"%");
			//PrintMessage(msg,HEALTHLEFTX,HEALTHLEFTY,RGB(255,0,0),TRUE);

			DoBlt(HEALTHBAR,0,HEALTHLEFTX,HEALTHLEFTY + size.cy,FALSE);
		}

	}

/*
	SIZE size,dummy;
	int tempx,x, y, frame;
	HDC hdc;
	PieceType type;
	

	//SetFont(14,0);
	x = 0; y = 0;
	int healthNum = 100;
	ovSurface->GetDC(&hdc);
	
	GetTextExtentPoint32(hdc,"HEALTH  :", strlen("Player  :"),&size);
	GetTextExtentPoint32(hdc,"Player  :", strlen("Player  :"),&dummy);
	ovSurface->ReleaseDC(hdc);
	
	width = dummy.cy+6;

	PrintMessage("STATISTICS for",x, y);
	// form the health message
	y = size.cy ;
	_itoa(healthNum,health,10);
	PrintMessage("HEALTH :  ",x,y);
	PrintMessage(health,x + size.cx,y);
	health[0] = '\0';

	// print the weapons I have
	
	ObjectMap::iterator it;
	it = mapPieces.find(myID);
	if (it != mapPieces.end()){
		// Print the login name on the left of the screen.
		if(((CClientPlayer*)(it->second))->name != NULL)
			PrintMessage(((CClientPlayer*)(it->second))->name, x+64,0);
		else
			PrintMessage("player", x+64,0);
		tempx = x + size.cx;
		y = y + size.cy;
		currentWeapon = ((CClientPlayer*)(it->second))->GetCurrentWeapon();
		PrintMessage("CUBES : ",x,y);

		// print all the cubes they have
		for (int k= 0; k < 6; k++){
			type =((CClientPlayer*)(it->second))->GetCenterCube(k);
			frame = GetCubeFrame(type,k);
			if (frame >= 0 ) {
				
				DoBlt(CUBE,frame,tempx,y,FALSE);
				tempx = tempx + CUBESPACE;
			}

		}
			
	
	}
	y = y + size.cy ;
	PrintMessage("WEAPONS :",x,y);
	tempx = x + size.cx;
	
	if (currentWeapon == Stomp) {
		
		tempx = tempx + WPLENGTH;
	} else if(currentWeapon == Tornado) {
	
		DoBlt(WEAPON1,0,tempx,y,FALSE);
		tempx = tempx + WPLENGTH;

	}*/
	//SetFont(11,0);
}

void
Overlay::DoBlt(BTYPE b, int frameNumber, int x, int y,BOOL rotate){
	
	if (ovSurface == NULL)
		return;

    HRESULT                 hr;
	RECT                    srcRect,destRect;
	long                    xleft, xright, ytop, 
							ybottom;
	DWORD                   bltFlags;
	int dx, dy;
	dx = 0; dy = 0;
    //if (hbm == NULL )
     //  return ;
	DDBLTFX ddbltfx;
	
    switch(b) {
	
	case CUBE:
		xleft = (frameNumber  * SQWIDTH);
		if (frameNumber >= 7) xleft = xleft + frameNumber - 3;

		else 
			if (frameNumber > 0) xleft = xleft + frameNumber - 1;

		xright= xleft + SQWIDTH;
		ytop = SQTOPY;
		ybottom = SQTOPY + SQWIDTH;
		destRect.right = x + CUBEWIDTH/2;
		destRect.bottom = y+ CUBEWIDTH/2;
	
		break;
	case CUBEICON:
		xleft = (frameNumber  * SQWIDTH);
		if (frameNumber > 0) xleft = xleft + frameNumber - 1;
		xright= xleft + SQWIDTH;
		ytop = SQTOPY;
		ybottom = SQTOPY + SQWIDTH;
		destRect.right =  (long)(x + scaleFact);
		destRect.bottom = (long)(y+ scaleFact);
		break;

	case BOUNDARY:
		xleft = LTOPX;
		xright = LBOTX;
		ytop = LTOPY;
		ybottom = LBOTY;
		destRect.right = x + 6 * (CUBEWIDTH)- CUBESPACE/2 + 2*WEAPONWIDTH + 4*SPACE;
		destRect.bottom = y + LWIDTH;
		if (rotate)
			bltFlags = DDBLT_ROTATIONANGLE | DDBLT_DDFX;
		else
			bltFlags = DDBLT_KEYSRC ;
		break;
	case RADAR:
		xleft = RADTOPX;
		xright = RADBOTX;
		ytop = RADTOPY;
		ybottom = RADBOTY;
		destRect.right= x+ xright - xleft;
		destRect.bottom = y +  ybottom - ytop;
		bltFlags =DDBLT_KEYSRC ;
		break;
	case MARBLE:
		xleft = frameNumber * MRWIDTH + frameNumber;
		xright= xleft + MRWIDTH;
		ytop = MRTOPY;
		ybottom = ytop + MRWIDTH;
		destRect.right = x + MRWIDTH/4;
		destRect.bottom = y + MRWIDTH/4;
		bltFlags = DDBLT_KEYSRC;
		//PrintMessage("inside marble case",2,2);
		break;
	case WEAPON1:
		xleft = frameNumber * WPLENGTH;
		xright = xleft + WPLENGTH;
		ytop = WPTOPY;
		ybottom = ytop + WPWIDTH;
		destRect.right = x + WPLENGTH;
		destRect.bottom = y + WPWIDTH;
		break;
	case BOX:
		xleft  = BOXTOPX;
		xright = BOXBOTX;
		ytop   = BOXTOPY;
		ybottom = BOXBOTY;
		destRect.right  = x + 6*(CUBEWIDTH/2)+CUBESPACE + CUBESPACE/2 ;
		destRect.bottom = y+ CUBEWIDTH/2 + SPACE;
		y = y - SPACE;
		x = x - SPACE;
		break;
	case HEALTHBAR:
		xleft = HEALTHBARTOPX;
		xright = xleft + HEALTHBARLENGTH;
		ytop = HEALTHBARTOPY;
		ybottom = ytop + HEALTHBARWIDTH;
		destRect.right = x + health;
		destRect.bottom	= y + HEALTHBARWIDTH/2;
		break;
	case FRAME:
		xleft = FRAMETOPX;
		xright = FRAMEBOTX;
		ytop = FRAMETOPY;
		ybottom = FRAMEBOTY;
		destRect.right = x + FRAMELENGTH;
		destRect.bottom = y + FRAMEWIDTH;
		x = x- 2;
		y = y -4;
		break;
	default:
		break;

	}
	srcRect.left = xleft;
	srcRect.right = xright;
	srcRect.top = ytop;
	srcRect.bottom = ybottom;

	destRect.left = x;
	destRect.top =  y;
	

    //hr = ovSurface->BltFast(x, y, pdds,
     //                                 &srcRect, DDBLTFAST_NOCOLORKEY);
	
	ddbltfx.dwSize = sizeof(ddbltfx);
	bltFlags = DDBLT_KEYSRC;
	//ddbltfx.dwDDFX = DDBLTFX_NOTEARING  ;
	if (rotate)
		ddbltfx.dwRotationAngle = 5;
	
	if (pdds){
			hr = ovSurface->Blt(&destRect, pdds, &srcRect, bltFlags, &ddbltfx);
	
			if(hr == DDERR_SURFACELOST){
				RestoreAll();
				//hr = ovSurface->Blt(&destRect, pdds, &srcRect, bltFlags, &ddbltfx);
			}
	}
}




//-----------------------------------------------------------------------------
// Name: DDColorMatch()
// Desc: Convert a RGB color to a pysical color.
//       We do this by leting GDI SetPixel() do the color matching
//       then we lock the memory and see what it got mapped to.
//-----------------------------------------------------------------------------
DWORD
Overlay::ColorMatch(IDirectDrawSurface4 * surface, COLORREF rgb)
{
    COLORREF                rgbT;
    HDC                     hdc;
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;

    //
    //  Use GDI SetPixel to color match for us
    //
    if (rgb != CLR_INVALID && surface->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, rgb);       // Set our value
        surface->ReleaseDC(hdc);
    }
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = surface->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface;                 // Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        surface->Unlock(NULL);
    }
    //
    //  Now put the color that was there back.
    //
    if (rgb != CLR_INVALID && surface->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        surface->ReleaseDC(hdc);
    }
    return dw;
}




//-----------------------------------------------------------------------------
// Name: DDSetColorKey()
// Desc: Set a color key for a surface, given a RGB.
//       If you pass CLR_INVALID as the color key, the pixel
//       in the upper-left corner will be used.
//-----------------------------------------------------------------------------
HRESULT
Overlay::SetColorKey(IDirectDrawSurface4 * surface,COLORREF rgb)
{
    DDCOLORKEY              ddck;

    ddck.dwColorSpaceLowValue = ColorMatch(surface,rgb);
    ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
    return surface->SetColorKey(DDCKEY_SRCBLT, &ddck);
}

