/*==========================================================================
 *
 *  Copyright (C) Drunken Mouse
 *
 *  File:       Boardjects.cpp
 *  Content:	Our static obstacle class for objects on the playing board
 *  Author:		Grant Jorde
 *
 ***************************************************************************/

#include <crtdbg.h>
#include "Boardjects.h"
#include "RubicsDirect3d.h"
#include "messages.h"
#include "ServerMissile.h"
#include "ServerWeapon.h"
#include "ServerRubiksPieceIcon.h"
#include "ServerHoming.h"
#include "ServerMortar.h"
#include "ServerRam.h"
CBoardjects::CBoardjects()
{
	object_count = 0;
}


/*CBoardjects::~CBoardjects()
{
	for(int i=0; i<object_count; i++){
		free(lpObjects[i]);
	}
	
}*/

LPServerObject CBoardjects::InsertBoardject(PieceType type, D3DRMBOX box,
											Position pos, float theta1, float scale, LPServerObject owner)
{
	Action no_action;
	no_action.velocity = 0;
	no_action.theta = 0;
	//D3DVALUE vel = 0;
	//D3DVALUE orient = 0;
	CServerObject * board_object;
	object_count++;

	switch(type) {
	case RICOCHETE:
	case MULTI_SHOT:
	case ARCING_OBJECT:
	case RAM_OBJECT:
	case TORNADO_OBJECT:
	case MISSILE:
			board_object = new CServerMissile(PIECE_ID(0, object_count-1), pos, box, owner);
			board_object->velocity = D3DVALUE(0);
			break;
	case RICOCHETE_PROJ:
			board_object = new CServerWeapon(PIECE_ID(0, object_count-1), pos, box, type, owner);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case HOMING_PROJ:
			board_object = new CServerHoming(PIECE_ID(0, object_count-1), pos, box, owner);
			//((CServerHoming *)board_object)->info.head = theta1;
			break;
	case RAM_BLOCK:
			board_object = new CServerRam(PIECE_ID(0, object_count-1), pos, box, owner);
			break;
	case MORTAR_PROJ:
	case CONECT_MORTAR_PROJ:
			board_object = new CServerMortar(PIECE_ID(0, object_count-1), pos, box, type, owner);
			((CServerMortar *)board_object)->info.head = theta1;
			break;
	case CUBE_PROJECTILE:
			board_object = new CServerWeapon(PIECE_ID(0, object_count-1), pos, box, type, owner);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case RED_RUBIKS_PIECE:
			board_object = new CServerRubiksPieceIcon(PIECE_ID(0, object_count-1), pos, box,owner, type);
			board_object->velocity = D3DVALUE(0);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case BLUE_RUBIKS_PIECE:
			board_object = new CServerRubiksPieceIcon(PIECE_ID(0, object_count-1), pos, box,owner, type);
			board_object->velocity = D3DVALUE(0);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case GREEN_RUBIKS_PIECE:
			board_object = new CServerRubiksPieceIcon(PIECE_ID(0, object_count-1), pos, box,owner, type);
			board_object->velocity = D3DVALUE(0);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case YELLOW_RUBIKS_PIECE:
			board_object = new CServerRubiksPieceIcon(PIECE_ID(0, object_count-1), pos, box,owner, type);
			board_object->velocity = D3DVALUE(0);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case WHITE_RUBIKS_PIECE:
			board_object = new CServerRubiksPieceIcon(PIECE_ID(0, object_count-1), pos, box,owner, type);
			board_object->velocity = D3DVALUE(0);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;
	case ORANGE_RUBIKS_PIECE:
			board_object = new CServerRubiksPieceIcon(PIECE_ID(0, object_count-1), pos, box,owner, type);
			board_object->velocity = D3DVALUE(0);
			((CServerWeapon *)board_object)->info.head = theta1;
			break;	
	case DECK:
			box.max.x *= scale; box.max.z *= scale; 
			board_object = new CServerObject(PIECE_ID(0, object_count-1), pos, box,owner);
			board_object->velocity = D3DVALUE(0);
			board_object->scale = scale;
			break;
	default:
			box.max.x *= scale; box.max.y *= scale; box.max.z *= scale; 
			board_object = new CServerObject(PIECE_ID(0, object_count-1), pos, box,owner);
			board_object->velocity = D3DVALUE(0);
			board_object->scale = scale;
			break;
	}
		
	board_object->Type = type;
	board_object->orientation = theta1;
	board_object->action = no_action;
	
	_ASSERT( board_object != NULL );
	return board_object;
}

