#ifndef _SERVER_H_
#define _SERVER_H_
/*****************************************************************************/
#include "Messages.h"
#include "ServerObject.h"
#include "ServerMovingObject.h"
#include "RubicsDirect3D.h"
#include "ServerPlayer.h"

/*These Bounding Boxes are pretty accurate as of 5/6/99 -Grant*/
const D3DRMBOX RUBIKS_PIECE_BOX = {-2.0f, 0.0f, -2.0f, 2.0f, 5.0f, 2.0f};
/* We don't use this box, anymore other than as a parameter.  The real values are in
   the ServerPlayer constructor. */
//const D3DRMBOX RUBICS_BOX = {-1.575f,0.0f,-1.575f, 1.575f,3.15f,1.575f};

typedef enum objectType {WALL_OBJECT,PLAYER_OBJECT,PROJECTILE_OBJECT};

#pragma warning(disable:4786)   // truncated characters in debug info

typedef map <long, LPServerObject > MAP_OBJECTS;
typedef map <long, LPServerMovingObject > MAP_MOVEABLE_OBJECTS;

extern void InitServer();
//extern VOID CALLBACK TimerProc(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime);
extern void BoardCastState(); 
extern void BroadcastMsg(DPMSG_GENERIC *lpMessage, DWORD size);
extern void AddPiece(SVRMSG_ADDPIECE * AddPieceMsg, PieceID &piece, D3DRMBOX &box, PieceType type, int team, char playername[]);
extern bool IsAddOK(PieceID &piece, PieceType type);
extern void SendCurrentObjectsMsg(DPID to_id);
extern void NewPlayerAdded(DPID to_id, char* name);
extern void DeletePlayerPiece(short player);
extern void InitBoard();
extern void RemoveObject(LPServerObject object);
void CreateProjectile(Position pos, D3DVALUE orientation, BOOL ricochete, CServerObject * owner);
extern void SendPickupPieceMsg(PieceID id, PieceType type);
extern void DeleteObjects();
extern void RemoveObjectFromGame(LPServerObject object);
extern bool Collision(LPServerObject cube, LPServerObject* other_object,LPD3DVECTOR normal,MAP_OBJECTS::iterator &it,bool reset,objectType type);
extern void MakeMove(PieceID & piece, Action & action);
extern void SendDropPieceMsg(PieceID id, PieceType type, CServerObject* object, PieceType weapon);
extern Position GetNextCameraPos(float* orient);
extern void DoWinningSeq(LPServerObject player);
extern LPServerObject  AddObject(PieceType type, D3DRMBOX box,Position pos, float theta, LPServerObject owner = NULL);
extern LPServerObject GetObjectFromID(PieceID id);
extern MAP_OBJECTS* GetPlayersMap();
extern void UpdateGame();
#endif //_SERVER_H_
