#include "ServerCube.h"
#include "ServerRubiksPieceIcon.h"
#include "Server.h"
#include "Boardjects.h"


CServerCube::CServerCube()
{
	info.head = 0.0f;
	
	info.pos.x = 200.0f;
	info.pos.y = 300.0f;
	info.pos.z = 200.0f;
	
	info.framecount = 0.0f;
	info.anim = STANDING;

	for (int i = 0; i < 6; i++)
		centerSquare[i] = false;
	velocity = 0.0f;
	action.velocity = 0.0f;
	action.theta =  0.0f;

	//Setup the bounding box. 
	box.min.x = -1.575f;
	box.min.y = 0.0f;
	box.min.z = -1.575f;
	box.max.x = 1.575f;
	box.max.y = 3.15f;
	box.max.z = 1.575f;

	currentWeapon = Ram;
}

CServerCube::CServerCube(int num_players)
{
	info.head = (float)PI/4.0f;

	info.pos.x = 200.0f;
	info.pos.y = 300.0f;
	info.pos.z = 200.0f;
	
	//Start the players in the four corners
	switch(num_players % 4){
	case 0:
		info.head = 3*(float)PI/4.0f;
		info.pos.x *= 1.0f;
		info.pos.z *= 1.0f;
		break;
	case 1:
		info.head = (float)PI/4.0f;
		info.pos.x *= -1.0f;
		info.pos.z *= 1.0f;
		break;
	case 2:
		info.head = 5*(float)PI/4.0f;
		info.pos.x *= 1.0f;
		info.pos.z *= -1.0f;
		break;
	case 3:
		info.head = 7*(float)PI/4.0f;
		info.pos.x *= -1.0f;
		info.pos.z *= -1.0f;
		break;
	default:
		break;
	}
	info.framecount = 0.0f;
	info.anim = STANDING;

	for (int i = 0; i < 6; i++)
		centerSquare[i] = false;
	velocity = 0.0f;
	action.velocity = 0.0f;
	action.theta =  0.0f;

	//Setup the bounding box. 
	box.min.x = -1.575f;
	box.min.y = 0.0f;
	box.min.z = -1.575f;
	box.max.x = 1.575f;
	box.max.y = 3.15f;
	box.max.z = 1.575f;

	currentWeapon = Ram;
}

CServerCube::~CServerCube()
{
	// I moved this to Server.cpp DeletePlayerPiece function -Grant
	/*for (int i = 0; i < 6; i++)
	{
		DropPiece();
	}*/

	//delete info;
}

D3DRMBOX CServerCube::GetBoundingBox() 
{
	D3DRMBOX temp;

	if (info.anim == ACTION2 && currentWeapon == Tornado)
	{
		temp.max.x = box.max.x * 2.0f;
		temp.max.y = box.max.y * 4.0f;
		temp.max.z = box.max.z * 2.0f;
		temp.min.x = box.min.x * 2.0f;
		temp.min.y = box.min.y;
		temp.min.z = box.min.z * 2.0f;
		return temp;
	}

	return box;
	
}

bool CServerCube::DoBeginFiring()
{	
	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_BEGINFIRING) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoFiring()
{	
	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_FIRING) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoEndFiring()
{	
	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_ENDFIRING) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoBeginAction2()
{
	switch (currentWeapon)
	{
		case Stomp:
		case Ram:
			return DoBeginStomp();
			break;
		case Tornado:
			return DoBeginTornado();
		case ArcingMortar:

			D3DVECTOR pos = info.pos;
			pos.y += 5.0;
			//this is temporary
			if(info.framecount == 0) AddObject(MORTAR_PROJ, box, pos, info.head, this);
			info.framecount++;
			if (info.framecount >= 30) 
			{
				info.framecount = 0;
				return true;
			}
			return false;
			break;
		default:
			info.anim = STANDING;
			break;
	}
	//Should never reach here
	//assert(0);
	return false;
}

bool CServerCube::DoAction2()
{
	switch (currentWeapon)
	{
		case Ram:
		case Stomp:
			return DoStomp();
			break;
		case Tornado:
			return DoTornado();
		case ArcingMortar:
			return true;
			break;
		default:
			info.anim = STANDING;
			break;
	}
	//Should never reach here
	//assert(0);
	return false;
}

bool CServerCube::DoEndAction2()
{
	switch (currentWeapon)
	{
		case Ram:
		case Stomp:
			return DoEndStomp();
			break;
		case Tornado:
			return DoEndTornado();
		case ArcingMortar:
			return true;
			break;
		default:
			info.anim = STANDING;
			break;
	}
	//Should never reach here
	//assert(0);
	return true;
}

bool CServerCube::DoBeginStomp()
{

	return true;
	//D3DVALUE  vel = 1.4f;

	//gravity = false;
	
	
/*
	info.pos.x += vel * (D3DVALUE)cos(info.head);
	info.pos.z -= vel * (D3DVALUE)sin(info.head);
	//info.pos.y += 3.0f;

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_BEGINSTOMP) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
	*/
}

bool CServerCube::DoStomp()
{
	gravity = false;
	yVelocity = 0.0f;
	dontTouch = true;

	D3DVALUE vel = 4.0f;

	info.pos.x += vel * (D3DVALUE)cos(info.head);
	info.pos.z -= vel * (D3DVALUE)sin(info.head);
	
	
	
	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_STOMP) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoEndStomp()
{
	//D3DVALUE  vel = 0.4f;

	dontTouch = false;
	gravity = true;

	return true;
	/*
	info.pos.x -= vel * (D3DVALUE)cos(info.head);
	info.pos.z += vel * (D3DVALUE)sin(info.head);

	if (info.framecount < MAX_ENDSTOMP / 2) info.pos.y += 1.0f;
	else info.pos.y -= 1.0f;

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_ENDSTOMP) 
	{
		info.framecount = 0;
		gravity = true;
		dontTouch = false;

		return true;
	}
	return false;
	*/
}

bool CServerCube::DoBeginTornado()
{
	D3DVALUE  vel = 1.4f;

	//Hurricane is a bad thing to touch!
	dontTouch = true;

	info.pos.x += vel * (D3DVALUE)cos(info.head);
	info.pos.z -= vel * (D3DVALUE)sin(info.head);

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_BEGINTORNADO) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoTornado()
{
	D3DVALUE  vel = 2.3f;
	
	info.pos.x += vel * (D3DVALUE)cos(info.head);
	info.pos.z -= vel * (D3DVALUE)sin(info.head);

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_TORNADO) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoEndTornado()
{
	D3DVALUE  vel = 1.0f;
	
	info.pos.x += vel * (D3DVALUE)cos(info.head);
	info.pos.z -= vel * (D3DVALUE)sin(info.head);

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_ENDTORNADO) 
	{
		//You can touch us again, no problem!
		dontTouch = false;
		info.framecount = 0;
		return true;
	}
	return false;
}


bool CServerCube::DoCollideWithProjectile()
{
	collideVel -= 0.15f;
	if (collideVel <0.0f) collideVel = 0.0f;
	
	info.pos.x += collideVel * (D3DVALUE)cos(collideHead);
	info.pos.z -= collideVel * (D3DVALUE)sin(collideHead);

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_COLLIDEWITHPROJECTILE)
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

bool CServerCube::DoCollideWithPlayer()
{
	collideVel -= 0.15f;
	if (collideVel <0.0f) collideVel = 0.0f;
	
	info.pos.x += collideVel * (D3DVALUE)cos(collideHead);
	info.pos.z -= collideVel * (D3DVALUE)sin(collideHead);

	info.framecount += ANIMATION_STEP_SIZE;
	if (info.framecount > MAX_COLLIDEWITHPLAYER)
	{
		info.framecount = 0;
		return true;
	}
	return false;
}

/* Get the next position for the hopping animation
 
	cube_move->AddPositionKey(0.0f,  0.0f, 0.0f, 0.0f);
	cube_move->AddPositionKey(4.0f,  1.2f, 0.0f, 0.0f);
	cube_move->AddPositionKey(15.0f,  3.6f, 0.0f, 0.0f);
	
	cube_move->AddPositionKey(24.0f,  4.3f, 0.0f, 0.0f);
	cube_move->AddPositionKey(30.0f,  4.3f, 0.0f, 0.0f);
	*/

bool CServerCube::DoForwardHop()
{
	D3DVALUE vel;
	if (action.velocity == DEFAULT_SPEED) 
		vel = 1.2f;
	else 
		vel = 2.7f;

		info.pos.x += vel * (D3DVALUE)cos(info.head);
		info.pos.z -= vel * (D3DVALUE)sin(info.head);


	//Don't animate if we're in the air
	if (!onGround) return false; 
	
	//Animate
	info.framecount += ANIMATION_STEP_SIZE; 
	if (info.framecount > MAX_HOPPING) 
	{
		info.framecount = 0;
		return true;
	}
	return false;

}

bool CServerCube::DoBackwardHop()
{
	velocity = -0.6f;
	info.pos.x += velocity * (D3DVALUE)cos(info.head);
	info.pos.z -= velocity * (D3DVALUE)sin(info.head);


	// Update which frame we're in. 
	info.framecount += ANIMATION_STEP_SIZE; 
	if (info.framecount > MAX_HOPPING) 
	{
		info.framecount = 0;
		return true;
	}
	return false;
}



void CServerCube::TurnRight()
{
	D3DVALUE spin;

	if (action.theta == -DEFAULT_THETA)
		spin = TURNING_RATE;
	else
		spin = 1.5f*TURNING_RATE;

	// If we're not strafing then turn.
	if(!action.strafe)
	{
		if (action.velocity < 0)
		{
			info.head -= spin;
			if (info.head <= D3DVAL(0)) info.head = (float)(2*PI);
			return;
		}
		
		info.head += spin;
		if (info.head >= 2*PI) info.head = 0.0f;
	}
	else
	{ // we're strafing
		velocity = -0.8f;
		info.pos.x += velocity * (D3DVALUE)cos(info.head - 1.57f);
		info.pos.z -= velocity * (D3DVALUE)sin(info.head - 1.57f);
	}
}

void CServerCube::TurnLeft()
{
	D3DVALUE spin;

	if (action.theta == DEFAULT_THETA)
		spin = TURNING_RATE;
	else
		spin = 1.5f*TURNING_RATE;

	// If we're not strafing then turn.
	if(!action.strafe)
	{
		if (action.velocity < 0)
		{
			info.head += spin;
			if (info.head >= 2*PI) info.head = 0.0f;
			return;
		}

		info.head -= spin;
		if (info.head <= D3DVAL(0)) info.head = (float)(2*PI);
	}
	else
	{ // we're strafing
		velocity = -0.8f;
		info.pos.x += velocity * (D3DVALUE)cos(info.head + 1.57f);
		info.pos.z -= velocity * (D3DVALUE)sin(info.head + 1.57f);
	}
}

//Pickups a piece if it can and returns if it did.  It also sends a message to update the state on
//The player app.
bool CServerCube::PickUp(PieceType type) 
{
	bool pickedup_piece =false;

	switch(type) 
	{
	case RED_RUBIKS_PIECE:
		if(centerSquare[RED_SQUARE])
			return false;
		centerSquare[RED_SQUARE] = true;
		pickedup_piece = true;
		break;
	case BLUE_RUBIKS_PIECE:
		if(centerSquare[BLUE_SQUARE])
			return false;
		centerSquare[BLUE_SQUARE] = true;
		pickedup_piece = true;
		break;
	case GREEN_RUBIKS_PIECE:
		if(centerSquare[GREEN_SQUARE])
			return false;
		centerSquare[GREEN_SQUARE] = true;
		pickedup_piece = true;
		break;
	case YELLOW_RUBIKS_PIECE:
		if(centerSquare[YELLOW_SQUARE])
			return false;
		centerSquare[YELLOW_SQUARE] = true;
		pickedup_piece = true;
		break;
	case WHITE_RUBIKS_PIECE:
		if(centerSquare[WHITE_SQUARE])
			return false;
		centerSquare[WHITE_SQUARE] = true;
		pickedup_piece = true;
		break;
	case ORANGE_RUBIKS_PIECE:
		if(centerSquare[ORANGE_SQUARE])
			return false;
		centerSquare[ORANGE_SQUARE] = true;
		pickedup_piece = true;
		break;
	case MISSILE:
		//CHANGE: Missile shouldn't be Tornado, Actually just remove the missile type
		currentWeapon = Tornado;
		pickedup_piece = true;

		dontTouch = false;
		/* In case gravity is off and we're picking up a new weapon,
	    turn it back on */
		gravity = true;
		break;
	case RAM_OBJECT:
		currentWeapon = Ram;
		pickedup_piece = true;

		dontTouch = false;
		/* In case gravity is off and we're picking up a new weapon,
	    turn it back on */
		gravity = true;
		break;

	case TORNADO_OBJECT:
		currentWeapon = Tornado;
		pickedup_piece = true;

		dontTouch = false;
		/* In case gravity is off and we're picking up a new weapon,
	    turn it back on */
		gravity = true;
		break;

	case ARCING_OBJECT:
		currentWeapon = ArcingMortar;
		pickedup_piece = true;

		dontTouch = false;
		/* In case gravity is off and we're picking up a new weapon,
	    turn it back on */
		gravity = true;
		break;

	case MULTI_SHOT:
		pickedup_piece = true;
		CannonPower1 = TRUE;
		dontTouch = false;
		/* In case gravity is off and we're picking up a new weapon,
	    turn it back on */
		gravity = true;
		break;

	case RICOCHETE:
		pickedup_piece = true;
		CannonPower2 = TRUE;
		dontTouch = false;
		/* In case gravity is off and we're picking up a new weapon,
	    turn it back on */
		gravity = true;
		break;

	default:
		pickedup_piece = false;
		break;
	}

	//check to see if we just won the game
	for(int i=0; i < 6; i++){
		if(centerSquare[i] == false)
			break;
		else if(i == 5){ // then we have all of them
			DoWinningSeq(this);
		}
	}

	if(pickedup_piece)	SendPickupPieceMsg(ID, type);
	
	return pickedup_piece;
}


void CServerCube::DropPiece(CServerObject* object, PieceType weapon)
{
	int piecesHeld[6];
	int index = 0;
	PieceType type;

	//Make a new array of only the pieces we have
	for (int i = 0; i < 6; i++)
	if (centerSquare[i])
	{
		piecesHeld[index] = i;
		index++;
	}

	//Terminate if we don't have any pieces
	if (index == 0) return;


	//Get a random index into that array
	int r = rand() % index;

	//Figure out which piece we're looking at
	switch (piecesHeld[r])
	{
		case RED_SQUARE:
			type = RED_RUBIKS_PIECE;
			break;
		case ORANGE_SQUARE:
			type = ORANGE_RUBIKS_PIECE;
			break;
		case GREEN_SQUARE:
			type = GREEN_RUBIKS_PIECE;
			break;
		case BLUE_SQUARE:
			type = BLUE_RUBIKS_PIECE;
			break;
		case WHITE_SQUARE:
			type = WHITE_RUBIKS_PIECE;
			break;
		case YELLOW_SQUARE:
			type = YELLOW_RUBIKS_PIECE;
			break;
		default:
			//We should never reach here!
			OutputDebugString("Dropping a random piece has failed! (ServerCube.cpp)");
			assert(0);
			break;
	}
	//Update our array saying that we're not holding the piece
	centerSquare[piecesHeld[r]] = false;

	if(CannonPower1)
		CannonPower1 = FALSE;
	else if(CannonPower2)
		CannonPower2 = FALSE;

	//Send a message to the client saying we've dropped the piece
	SendDropPieceMsg(ID, type, object, weapon);

	//Add a new icon to the board
	LPServerObject   lpObject;
	D3DVECTOR        pos;

	pos.x = info.pos.x; 
	pos.y = 4.0f + info.pos.y; 
	pos.z = info.pos.z;
	
	
	lpObject = AddObject(type, RUBIKS_PIECE_BOX, pos, (PI * (float) (rand() % 180) / 180.0f));
	((CServerMovingObject *)lpObject ) ->velocity = (rand() % 6)* 0.2+ 1.0f;
	((CServerMovingObject *)lpObject ) ->yVelocity =(rand() % 3) + 4.0f;
	//InsertObject(lpObject);

}