// ServerIcon.cpp: implementation of the CServerIcon class.
//
//////////////////////////////////////////////////////////////////////

#include "ServerIcon.h"
#include "ServerCube.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CServerIcon::CServerIcon() : CServerObject()
{
	counter = 0;
}

CServerIcon::CServerIcon(long PieceID, Position npos,D3DRMBOX nbox, CServerObject * owner) : CServerObject(PieceID, npos, nbox, owner) {
	counter = 0;
}

CServerIcon::CServerIcon(long PieceID, Position npos,D3DRMBOX nbox) : CServerObject(PieceID, npos, nbox) {
	counter = 0;
}

CServerIcon::CServerIcon(Position npos,D3DRMBOX nbox) : CServerObject(npos, nbox)
{
	counter = 0;
}

CServerIcon::~CServerIcon()
{
}

bool CServerIcon::CollideWith(CServerObject * object) {
	if(object->IsPlayer()) {
		if (((CServerPlayer *) object)->PickUp(Type))
		{
			counter = 200;
			RemoveObjectFromGame(this);
			return true;
		}
	}
	return false;
}


bool CServerIcon::TimerRegen() {
	if(counter <= 0)
		return true;
	else{
		counter--;
		return false;
	}
}