/*CServerPlayer is the super class for all the player subclasses*/
#include "messages.h"
#include "ServerPlayer.h"
#include "rubiksInfo.h"

void CServerMovingObject::ReceiveAction(Action &a)
{

}

void CServerMovingObject::Update() {
	//info.head = fmod(info.head + delta_theta, 2*PI);	

	if(velocity) {
		info.pos.x += velocity * D3DVAL(cos(info.head));
		info.pos.z -= velocity * D3DVAL(sin(info.head));

		D3DVECTOR normal;
		rubiks_info temp_info;
		CServerObject * other_object;

		//Make a copy of our info (we may need to erase it in case of a collision)
		info.copy(temp_info);
		
		//Check for a collision 
	
		MAP_OBJECTS::iterator wall_it;
		bool reset = true;
		while (Collision(this, &other_object,&normal,wall_it,reset,WALL_OBJECT))
		{
			collide_normal = normal;
			reset = false;
			CollideWith(other_object);
			other_object->CollideWith(this);
		}
	}
}

void CServerMovingObject::GetMessage(rubiks_info* buffer)
{
	memcpy(buffer, &info, sizeof(rubiks_info));
}

bool CServerMovingObject::IsMoveable() {
	return true;
}

Position CServerMovingObject::GetPosition() {
	return info.pos;
}

D3DVALUE CServerMovingObject::GetOrientation() {
	return info.head;
}

CServerMovingObject::CServerMovingObject() : CServerObject()
{
	memset(&action, 0 , sizeof(Action));
	memset(&info, 0 , sizeof(rubiks_info ));	
	yVelocity = 0;
}

CServerMovingObject::CServerMovingObject(long PieceID, Position npos,D3DRMBOX nbox, CServerObject * owner) : CServerObject(PieceID, npos, nbox, owner) {
	memset(&action, 0 , sizeof(Action));
	memset(&info, 0 , sizeof(rubiks_info ));	
	info.pos = npos;
	yVelocity = 0;
}

CServerMovingObject::CServerMovingObject(long PieceID, Position npos,D3DRMBOX nbox) : CServerObject(PieceID, npos, nbox) {
	memset(&action, 0 , sizeof(Action));
	memset(&info, 0 , sizeof(rubiks_info ));	
	info.pos = npos;
	yVelocity = 0;
}

CServerMovingObject::CServerMovingObject(Position npos,D3DRMBOX nbox) : CServerObject(npos, nbox)
{
	memset(&action, 0 , sizeof(Action));
	memset(&info, 0 , sizeof(rubiks_info ));	
	info.pos = npos;
	yVelocity = 0;
}
