#ifndef _SERVER_MOVING_OBJECT_H_
#define _SERVER_MOVING_OBJECT_H_

#include "ServerObject.h"
#include "rubiksInfo.h"

typedef class CServerMovingObject : public CServerObject
{

public:

	/* What should this return? */
	virtual void Update();
	virtual Position GetPosition();
	virtual D3DVALUE GetOrientation();
	CServerMovingObject();

	virtual bool IsWall() {return false;}
	
	CServerMovingObject(Position pos,D3DRMBOX box);
	CServerMovingObject(long ID, Position pos,D3DRMBOX box);
	CServerMovingObject(long ID, Position pos,D3DRMBOX box, CServerObject * owner);
	/* Returns a pointer to the internal
	   info for this object. This is what will
	   be passed as a message */
	virtual void GetMessage(rubiks_info* buffer);
	virtual void ReceiveAction(Action &a);
	virtual bool IsMoveable();

public:
	Action action;
	rubiks_info info;
	D3DVALUE yVelocity;
	//This is used for our ricochete projectiles.
	D3DVECTOR collide_normal;
}*LPServerMovingObject;


#endif //_SERVER_MOVING_OBJECT_H_