#include"ServerObject.h"
#include<math.h>
#define PI 3.1415926

bool collide(CServerObject* obj1,CServerObject* obj2,LPD3DVECTOR result)
{
	D3DVECTOR box1[4],box2[4], temp;
	D3DRMBOX obox1,obox2;
	float distance = 0.0f;
	int i,j;
	float m1,b1,m2,b2;
	float so2,co2,so1,co1;
	float factor;
	bool not_both;
	so1 = sin(obj1->GetOrientation());
	co1 = cos(obj1->GetOrientation());
	so2 = sin(obj2->GetOrientation());
	co2 = cos(obj2->GetOrientation());
	obox1 = obj1->GetBoundingBox();
	obox2 = obj2->GetBoundingBox();
	if(result != NULL)
	{
		result->x =0.0f;
		result->y =0.0f;
		result->z =0.0f;
	}


	if(obox1.max.y + obj1->GetPosition().y < obj2->GetPosition().y + obox2.min.y || obj1->GetPosition().y + obox1.min.y > obox2.max.y + obj2->GetPosition().y)
	{
		return false;
	}
	float d1,d2,dtx,dtz;
	d1 = obox1.max.x * obox1.max.x + obox1.max.z * obox1.max.z;
	d2 = obox2.max.x * obox2.max.x + obox2.max.z * obox2.max.z;
	dtx = (obj1->GetPosition().x - obj2->GetPosition().x) * (obj1->GetPosition().x - obj2->GetPosition().x);
	dtz = (obj1->GetPosition().z - obj2->GetPosition().z) * (obj1->GetPosition().z - obj2->GetPosition().z);
	//Bounding circle, set up to not use sqrt
	if((((4 * d1 * d2) < ((dtx + dtz - d1 - d2) * (dtx + dtz - d1 - d2))) && ((dtx + dtz - d1 - d2) > 0)))
		return false;
	box1[0].x = obox1.max.x;
	box1[0].z = obox1.max.z;
	box1[1].x = obox1.max.x;
	box1[1].z = obox1.min.z;
	box1[2].x = obox1.min.x;
	box1[2].z = obox1.min.z;
	box1[3].x = obox1.min.x;
	box1[3].z = obox1.max.z;
	
	box2[0].x = obox2.max.x;
	box2[0].z = obox2.max.z;
	box2[1].x = obox2.max.x;
	box2[1].z = obox2.min.z;
	box2[2].x = obox2.min.x;
	box2[2].z = obox2.min.z;
	box2[3].x = obox2.min.x;
	box2[3].z = obox2.max.z;

	for(i = 0;i < 4;i++)
	{	
		temp = box1[i];
		box1[i].x = temp.x * co1 - temp.z * so1;
		box1[i].z = temp.x * so1 + temp.z * co1;
		
		
		box1[i].x += obj1->GetPosition().x;
		box1[i].z += obj1->GetPosition().z;
		
		box1[i].x -= obj2->GetPosition().x;
		box1[i].z -= obj2->GetPosition().z;

		temp = box1[i];
		box1[i].x = temp.x * co2 + temp.z * so2;
		box1[i].z = - temp.x * so2 + temp.z * co2;
		
	}

	for(i = 0;i < 4;i++)
	{
		for(j = 0;j < 4;j++)
		{
			not_both = false;
			if((box1[i].x - box1[(i + 1)%4].x) != 0)
			{
				m1 = (box1[i].z - box1[(i + 1)%4].z)/(box1[i].x - box1[(i + 1)%4].x);
				b1 = box1[i].z - m1 * box1[i].x;
				not_both = true;
			}
			if((box2[j].x - box2[(j + 1)%4].x) != 0)
			{
				m2 = (box2[j].z - box2[(j + 1)%4].z)/(box2[j].x - box2[(j + 1)%4].x);
				b2 = box2[j].z - m2 * box2[j].x;
				not_both = !not_both;
			}
			if((m1 - m2) != 0 || not_both)
			{
				if((box1[i].x - box1[(i + 1)%4].x) == 0)
				{
					if((box2[j].x - box2[(j + 1)%4].x) != 0)
					{

						if((box2[j].z <= box1[i].z && box2[j].z >= box1[(i + 1)%4].z) || (box2[j].z >= box1[i].z && box2[j].z <= box1[(i + 1)%4].z))
						{
							if((box1[i].x <= box2[j].x && box1[i].x >= box2[(j + 1)%4].x) || (box1[i].x >= box2[j].x && box1[i].x <= box2[(j + 1)%4].x))
							{
								factor = sqrt(m2 * m2 + 1.0f);
								if(result != NULL)
								{
									result->z = -(1.0f / factor) * co2 + (m2 / factor) * so2;
									result->x = (1.0f / factor) * so2 + (m2 / factor) * co2;
								}

								return true;
							}
						}
					}
				}else if((box2[j].x - box2[(j + 1)%4].x) == 0)
				{
					temp.z = box2[j].x * m1 + b1;
					if((temp.z < box1[i].z && temp.z > box1[(i + 1)%4].z) || (temp.z > box1[i].z && temp.z < box1[(i + 1)%4].z)) 
						if((temp.z < box2[j].z && temp.z > box2[(j + 1)%4].z) || (temp.z > box2[j].z && temp.z < box2[(j + 1)%4].z)) 
						{
							if(result != NULL)
							{
								result->z = sin(obj2->GetOrientation());
								result->x = cos(obj2->GetOrientation());
							}
							return true;
						}

				}else
				{
					temp.x = (b2 - b1)/(m1 - m2);
					if((temp.x < box1[i].x && temp.x > box1[(i + 1)%4].x) || (temp.x > box1[i].x && temp.x < box1[(i + 1)%4].x)) 
						if((temp.x < box2[j].x && temp.x > box2[(j + 1)%4].x) || (temp.x > box2[j].x && temp.x < box2[(j + 1)%4].x)) 
						{
							factor = sqrt(m2 * m2 + 1.0f);
							if(result != NULL)
							{
								result->z = -(1.0f / factor) * co2 + (m2 / factor) * so2;
								result->x = (1.0f / factor) * so2 + (m2 / factor) * co2;
							}
							return true;
						}
				}
			}
			
		}
	}

	for(i = 0;i < 4;i++)
	{
		if(box1[i].x < obox2.max.x && box1[i].x > obox2.min.x && box1[i].z < obox2.max.z && box1[i].z > obox2.min.z)
		{
			if(result != NULL)
			{
				result->y = 1.0f;
			}
			return true;
		}
	}

	return false;
}

CServerObject::CServerObject() {
	ID = NULL;
	scale = 1.0f;
}

CServerObject::CServerObject(long PieceID, Position npos,D3DRMBOX nbox) {
	ID = PieceID;
	pos = npos;
	box = nbox;
	scale = 1.0f;
}

CServerObject::CServerObject(Position npos,D3DRMBOX nbox)
{
	ID = NULL;
	pos = npos;
	box = nbox;
	scale = 1.0f;
}
CServerObject::CServerObject(long PieceID, Position npos,D3DRMBOX nbox, CServerObject * own) {
	ID = PieceID;
	pos = npos;
	box = nbox;
	owner = own;
	scale = 1.0f;
}


bool CServerObject::IsMoveable() {
	return false;
}
D3DRMBOX CServerObject::GetBoundingBox() {
	return box;
}
Position CServerObject::GetPosition() {
	return pos;
}
D3DVALUE CServerObject::GetOrientation() {
	return orientation;
}

long CServerObject::GetID() {
	return ID;
}

bool CServerObject::IsProjectile() 
{
	return false;
}

bool CServerObject::IsPlayer()
{
	return false;
}

bool CServerObject::IsIcon()
{
	return false;
}

bool CServerObject::IsWall()
{
	return true;
}

CServerObject * CServerObject::GetOwner() {
	return owner;
}

bool CServerObject::CollideWith(CServerObject * object) {
	return false;
}

CServerObject::SetBox(D3DRMBOX m_box)
{
	box = m_box;
}
CServerObject::SetPos(Position m_pos)
{
	pos = m_pos;
}