#ifndef _SERVER_OBJECT_H_
#define _SERVER_OBJECT_H_

#include "messages.h"

class CServerObject
{


public:
	Action action;
	CServerObject();
	CServerObject(Position pos,D3DRMBOX box);
	CServerObject(long ID, Position pos,D3DRMBOX box);
	CServerObject(long ID, Position pos,D3DRMBOX box, CServerObject * owner);
	SetBox(D3DRMBOX);
	SetPos(Position);

	virtual bool IsProjectile();
	virtual bool IsPlayer();
	virtual bool IsWall();
	virtual bool IsIcon();

	//Returns the object that created you if any.
	virtual D3DRMBOX GetBoundingBox();

	virtual Position GetPosition();

	virtual D3DVALUE GetOrientation();
	virtual CServerObject * GetOwner();
	virtual bool CollideWith(CServerObject * object);

	long GetID();

	virtual bool IsMoveable();

	/* Member variables */
public:
	PieceType Type;
	long ID;
	float scale; //only for non-moving objects for now
	char name[10];
	
	//Action act;
	D3DVALUE velocity;
	D3DVALUE orientation;
	
protected:
	CServerObject * owner;
	Position pos;
	D3DRMBOX box;
};

typedef CServerObject *LPServerObject;

bool collide(LPServerObject,LPServerObject,LPD3DVECTOR result);

/*
class object_wall : public Object
{
private:
public:
	object_wall();
	object_wall(Position pos,D3DRMBOX box);
	Animation get_animation();
	void PerformAction();
};
*/

class ServerWeapon : public Object
{



};

#endif //_SERVEROBJECT_H_
