// ServerRam.cpp: implementation of the CServerRam class.
//
//////////////////////////////////////////////////////////////////////

#include "ServerRam.h"
#include "ServerPlayer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CServerRam::~CServerRam()
{

}

CServerRam::CServerRam(Position p, D3DRMBOX b) : CServerWeapon(p, b)
{
	info.anim = STANDING;
}
CServerRam::CServerRam(long PieceID, Position p,D3DRMBOX b) : CServerWeapon(PieceID, p, b){
}

CServerRam::CServerRam(long PieceID, Position p,D3DRMBOX b, CServerObject * own) :CServerWeapon(PieceID, p, b, RAM_BLOCK, own) {
	info.anim = STANDING;
}

bool CServerRam::CollideWith(CServerObject * object) {
	if(object != owner ) {
		if(object) {
			if(object->IsPlayer()) {
				((CServerPlayer *)object)->DoDamage(80, this, RAM_OBJECT);
			}
		}
	}
	return false;
}
void CServerRam::SetPosition(float x, float y, float z) {
	info.pos.x = x;
	info.pos.y = y;
	info.pos.z = z;
}

void CServerRam::SetOrientation(float theta) {
	info.head = theta;
}

void CServerRam::Update() {
	return;
}
bool CServerRam::IsProjectile() {
	return true;
}
