// ServerRubiksPieceIcon.cpp: implementation of the CServerRubiksPieceIcon class.
//
//////////////////////////////////////////////////////////////////////

#include "ServerRubiksPieceIcon.h"
#include "ServerCube.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CServerRubiksPieceIcon::CServerRubiksPieceIcon () : CServerMovingObject()
{
}

CServerRubiksPieceIcon::CServerRubiksPieceIcon(long PieceID, Position npos,D3DRMBOX nbox, CServerObject * owner, PieceType t) : CServerMovingObject(PieceID, npos, nbox, owner) {
	Type = t;
}
CServerRubiksPieceIcon::CServerRubiksPieceIcon(long PieceID, Position npos,D3DRMBOX nbox, CServerObject * owner) : CServerMovingObject(PieceID, npos, nbox, owner) {
}

CServerRubiksPieceIcon::CServerRubiksPieceIcon(long PieceID, Position npos,D3DRMBOX nbox) : CServerMovingObject(PieceID, npos, nbox) {
}

CServerRubiksPieceIcon::CServerRubiksPieceIcon(Position npos,D3DRMBOX nbox) : CServerMovingObject(npos, nbox)
{
}

CServerRubiksPieceIcon::~CServerRubiksPieceIcon()
{
}

bool CServerRubiksPieceIcon::CollideWith(CServerObject * object) {
	if(object->IsPlayer())
	{
		if (((CServerPlayer *) object)->PickUp(Type))
		{
			RemoveObjectFromGame(this);
			return true;
		}
	} 
	return false;
}

void CServerRubiksPieceIcon::Update() {
	bool onGround = false;
	rubiks_info temp_info;
	CServerObject * other_object;
	D3DVECTOR normal;
	Position pos;
	Position vel;
	float dot;

	//Make a copy of our info (we will need to erase our move it in case of a collision)
	info.copy(temp_info);


	//GRAVITY
	if (yVelocity > -4.0f) yVelocity -= 0.2f; 
			
	info.pos.y += yVelocity;
	if (info.pos.y < 0.0f)
	{
		info.pos.y = 0.0f;
		  onGround = true;
	  }
	

	info.pos.x += velocity * D3DVAL(cos(info.head));
	info.pos.z -= velocity * D3DVAL(sin(info.head));

	pos.x = info.pos.x;
	pos.y = info.pos.y;
	pos.z = info.pos.z;

	
	vel.x = info.pos.x - temp_info.pos.x;
	vel.z = info.pos.z - temp_info.pos.z;
	vel.y = info.pos.y - temp_info.pos.y;
	
	int num_times = 0;
	bool collisions = true;
	bool reset;
	bool next_reset = true;

	
	MAP_OBJECTS::iterator wall_it;
	//Check for a collision 
	
	while (collisions && num_times < 4)	
	{	
		reset = next_reset;
		next_reset = false;
		collisions = false;
		num_times++;
	
/*		if (Collision(this, &other_object,&normal,wall_it,reset,WALL_OBJECT))
		{				
			//Tell the other object we hit it.
			other_object->CollideWith(this);

			//we need to keep colliding with objects, and reset the iterators
			collisions = true;
			float my_temp;


			my_temp = info.pos.y;
			//Check if the collision was caused by gravity;
			info.pos.y = temp_info.pos.y;
			if(collide(this,other_object,NULL))
			{
				//make sure the normal is acceptable
				if(normal.y > 0.0f)
				{
					normal.y = 0.0f;
					normal.x = 1.0f;
				}
				info.pos.y = my_temp;
				temp_info.pos.x = info.pos.x;
				temp_info.pos.y = info.pos.y;
				temp_info.pos.z = info.pos.z; 
				//calculate the dot product, and the new bounced position
				dot = vel.x * normal.x + vel.y * normal.y + vel.z * normal.z;
				info.pos.x -= 2 * dot * normal.x;
				info.pos.z -= 2 * dot * normal.z;
				info.pos.y -= 2 * dot * normal.y;
				//check if collision was on the corner of the object, and hit
				//multiple sides
				if(collide(this,other_object,NULL))
				{
					
					//Reset the position of the object
					info.pos.x = temp_info.pos.x;
					info.pos.y = temp_info.pos.y;
					info.pos.z = temp_info.pos.z; 
					//Undo the rotation
					info.head = temp_info.head;

					my_temp = normal.x;
					normal.x = -normal.z;
					normal.z = my_temp;
					
					temp_info.pos.x = info.pos.x;
					temp_info.pos.y = info.pos.y;
					temp_info.pos.z = info.pos.z; 
					//calculate the dot product, and the new bounced position
					dot = vel.x * normal.x + vel.y * normal.y + vel.z * normal.z;
					info.pos.x -= 2 * dot * normal.x;
					info.pos.z -= 2 * dot * normal.z;
					info.pos.y -= 2 * dot * normal.y;
				}

			}
			else
			{
				//if the collision was due to falling set the position to the top
				//of the object;
				//If we're colliding with the ground, set the  boolean so we'll know
				if(vel.y > 0.0)
				{
					info.pos.y = other_object->GetPosition().y - this->GetBoundingBox().max.y - 0.01;
				}else
				{
					onGround = true;
					info.pos.y = other_object->GetBoundingBox().max.y 
					        + other_object->GetPosition().y + 0.01;
				}
			}
			next_reset = true;
			//Determine vel of object
			vel.x = info.pos.x - temp_info.pos.x;
			vel.z = info.pos.z - temp_info.pos.z;
			vel.y = info.pos.y - temp_info.pos.y;
		}
	}
*/		if (Collision(this, &other_object,&normal,wall_it,reset,WALL_OBJECT))
		{				
			//Tell the other object we hit it.
			other_object->CollideWith(this);

			//we need to keep colliding with objects, and reset the iterators
			collisions = true;
			float my_temp;


			my_temp = info.pos.y;
			//Check if the collision was caused by gravity;
			info.pos.y = temp_info.pos.y;
			if(collide(this,other_object,NULL))
			{
				//make sure the normal is acceptable
				if(normal.y > 0.0f)
				{
					normal.y = 0.0f;
					normal.x = 1.0f;
				}
				info.pos.y = my_temp;
			//	temp_info.pos.x = info.pos.x;
			//	temp_info.pos.y = info.pos.y;
			//	temp_info.pos.z = info.pos.z; 
				//calculate the dot product, and the new bounced position
				dot = vel.x * normal.x + vel.y * normal.y + vel.z * normal.z;
				info.pos.x -= 2 * dot * normal.x;
				info.pos.z -= 2 * dot * normal.z;
				info.pos.y -= 2 * dot * normal.y;
				//check if collision was on the corner of the object, and hit
				//multiple sides
				if(collide(this,other_object,NULL))
				{
					
					//Reset the position of the object
					info.pos.x = temp_info.pos.x;
					info.pos.y = temp_info.pos.y;
					info.pos.z = temp_info.pos.z; 
				
					my_temp = normal.x;
					normal.x = -normal.z;
					normal.z = my_temp;
					
			//		temp_info.pos.x = info.pos.x;
			//		temp_info.pos.y = info.pos.y;
			//		temp_info.pos.z = info.pos.z; 
					//calculate the dot product, and the new bounced position
					dot = vel.x * normal.x + vel.y * normal.y + vel.z * normal.z;
					info.pos.x -= 2 * dot * normal.x;
					info.pos.z -= 2 * dot * normal.z;
					info.pos.y -= 2 * dot * normal.y;
				}

				if(collide(this,other_object,NULL))
				{
					
					//Reset the position of the object
					info.pos.x = temp_info.pos.x;
					info.pos.y = temp_info.pos.y;
					info.pos.z = temp_info.pos.z; 
					//Undo the rotation
					info.head = temp_info.head;
				}




			}
			else
			{
				//if the collision was due to falling set the position to the top
				//of the object;
				//If we're colliding with the ground, set the  boolean so we'll know
				if(vel.y > 0.0)
				{
					info.pos.y = other_object->GetPosition().y + other_object->GetBoundingBox().min.y - this->GetBoundingBox().max.y - 0.01;
					
				}else
				{
					onGround = true;
					info.pos.y = other_object->GetBoundingBox().max.y 
							+ other_object->GetPosition().y + 0.01 + this->GetBoundingBox().min.y;
				}
						
			}
			//set to reset all iterators during next pass because position changed
			next_reset = true;
			//Determine velocity of object
			vel.x = info.pos.x - temp_info.pos.x;
			vel.z = info.pos.z - temp_info.pos.z;
			vel.y = info.pos.y - temp_info.pos.y;
		}
	}
	if(onGround)
		velocity = 0;
}