// ServerWeapon.h: interface for the CServerWeapon class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVERWEAPON_H__86AC95C3_FB3D_11D2_9252_006097BC1F86__INCLUDED_)
#define AFX_SERVERWEAPON_H__86AC95C3_FB3D_11D2_9252_006097BC1F86__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define TIMER_LIFE 60
#include "ServerMovingObject.h"
#include "Messages.h"

class CServerWeapon : public CServerMovingObject  
{
public:
	CServerWeapon();
	CServerWeapon(Position p, D3DRMBOX box);
	CServerWeapon(long PieceID, Position npos,D3DRMBOX nbox);
	CServerWeapon(long PieceID, Position p,D3DRMBOX b, PieceType type, CServerObject *own);

	virtual bool IsProjectile();
	virtual bool CollideWith(CServerObject * object);
	virtual ~CServerWeapon();
	virtual void TimerDestroy();

	float delta_theta;
	
protected:
	float NewHeading(D3DVECTOR normal);
	// count down for a time period until deletion of this projectile
	int counter;
	PieceType projectile_type;
};

#endif // !defined(AFX_SERVERWEAPON_H__86AC95C3_FB3D_11D2_9252_006097BC1F86__INCLUDED_)
