#include"objects.h"
#include<math.h>
#define PI 3.1415926f

bool collide(Object_A obj1,Object_A obj2)
{
	float relative_angle,obj1_angle,obj2_angle;
	D3DVECTOR box1[4],box2[4], temp;
	float distance = 0.0f;
	int i,j;
	float m1,b1,m2,b2;


	D3DVECTOR min1,min2,max1,max2;
	min1 = obj1.box.min;
	min2 = obj2.box.min;
	max1 = obj1.box.max;
	max2 = obj2.box.max;
	float min1x,min1y,min1z,max1x,max1y,max1z,min2x,min2y,min2z,max2x,max2y,max2z;
	min1x = min1.x + obj1.pos.x;
	min1y = min1.y + obj1.pos.y;
	min1z = min1.z + obj1.pos.z;	
	max1x = max1.x + obj1.pos.x;
	max1y = max1.y + obj1.pos.y;
	max1z = max1.z + obj1.pos.z;
	min2x = min2.x + obj2.pos.x;
	min2y = min2.y + obj2.pos.y;
	min2z = min2.z + obj2.pos.z;	
	max2x = max2.x + obj2.pos.x;
	max2y = max2.y + obj2.pos.y;
	max2z = max2.z + obj2.pos.z;

	if(obj1.box.max.y + obj1.pos.y < obj2.box.min.y + obj2.pos.y || obj1.box.min.y + obj1.pos.y > obj2.box.max.y + obj2.pos.y)
		return false;

	box1[0].x = obj1.box.max.x;
	box1[0].z = obj1.box.max.z;
	box1[1].x = obj1.box.max.x;
	box1[1].z = obj1.box.min.z;
	box1[2].x = obj1.box.min.x;
	box1[2].z = obj1.box.min.z;
	box1[3].x = obj1.box.min.x;
	box1[3].z = obj1.box.max.z;
	
	box2[0].x = obj2.box.max.x;
	box2[0].z = obj2.box.max.z;
	box2[1].x = obj2.box.max.x;
	box2[1].z = obj2.box.min.z;
	box2[2].x = obj2.box.min.x;
	box2[2].z = obj2.box.min.z;
	box2[3].x = obj2.box.min.x;
	box2[3].z = obj2.box.max.z;

	for(i = 0;i < 4;i++)
	{	
		temp = box1[i];
		box1[i].x = temp.x * cos(obj1.dir.theta_xz) - temp.z * sin(obj1.dir.theta_xz);
		box1[i].z = temp.x * sin(obj1.dir.theta_xz) + temp.z * cos(obj1.dir.theta_xz);
		
		temp = box2[i];
		box2[i].x = temp.x * cos(obj2.dir.theta_xz) - temp.z * sin(obj2.dir.theta_xz);
		box2[i].z = temp.x * sin(obj2.dir.theta_xz) + temp.z * cos(obj2.dir.theta_xz);
		
		box1[i].x += obj1.pos.x;
		box1[i].z += obj1.pos.z;
		
		box2[i].x += obj2.pos.x;
		box2[i].z += obj2.pos.z;
	}

	for(i = 0;i < 4;i++)
	{
		for(j = 0;j < 4;j++)
		{
			m1 = 1.0f;
			m2 = 0.0f;
			if((box1[i].x - box1[(i + 1)%4].x) != 0)
			{
				m1 = (box1[i].z - box1[(i + 1)%4].z)/(box1[i].x - box1[(i + 1)%4].x);
				b1 = box1[i].z - m1 * box1[i].x; 
			}
			if((box2[i].x - box2[(i + 1)%4].x) != 0)
			{
				m2 = (box2[i].z - box2[(i + 1)%4].z)/(box2[i].x - box2[(i + 1)%4].x);
				b2 = box2[i].z - m2 * box2[i].x;
			}
			if((m1 - m2) != 0)
			{
				if((box1[i].x - box1[(i + 1)%4].x) == 0)
				{
					if((box2[i].x - box2[(i + 1)%4].x) != 0)
					{
						temp.y = box1[i].x * m2 + b2;
						if((temp.y < box1[i].y && temp.y > box1[(i + 4)%4].y) || (temp.y > box1[i].y && temp.y < box1[(i + 4)%4].y)) 
							if((temp.y < box2[i].y && temp.y > box2[(i + 4)%4].y) || (temp.y > box2[i].y && temp.y < box2[(i + 4)%4].y)) 
								return true;
					}
				}else if((box2[i].x - box2[(i + 1)%4].x) == 0)
				{
					temp.y = box2[i].x * m1 + b1;
					if((temp.y < box1[i].y && temp.y > box1[(i + 4)%4].y) || (temp.y > box1[i].y && temp.y < box1[(i + 4)%4].y)) 
						if((temp.y < box2[i].y && temp.y > box2[(i + 4)%4].y) || (temp.y > box2[i].y && temp.y < box2[(i + 4)%4].y)) 
							return true;

				}else
				{
					temp.x = (b2 - b1)/(m1 - m2);
					temp.z = m1 * temp.x + b1;
			
					if((temp.x < box1[i].x && temp.x > box1[(i + 4)%4].x) || (temp.x > box1[i].x && temp.x < box1[(i + 4)%4].x)) 
						if((temp.x < box2[i].x && temp.x > box2[(i + 4)%4].x) || (temp.x > box2[i].x && temp.x < box2[(i + 4)%4].x)) 
							return true;
				}
			}
			
		}
	}

/*	relative_angle = atan2(obj2.pos.x - obj1.pos.x,obj2.pos.z - obj1.pos.z);
	obj1_angle = relative_angle + obj1.dir.theta_xz;
	obj2_angle = relative_angle + obj2.dir.theta_xz;
	if(obj1_angle < 0)
		while(obj1_angle < 0)
			obj1_angle += PI/2.0;
	else
		while(obj1_angle > PI/2.0)
			obj1_angle -= PI/2.0;
	if(obj2_angle < 0)
		while(obj2_angle < 0)
			obj2_angle += PI/2.0;
	else
		while(obj2_angle > PI/2.0)
			obj2_angle -= PI/2.0;



	if(atan2(obj1.box.max.x,obj1.box.max.z) > obj1_angle)
	{
		distance += obj1.box.max.x / cos(obj1_angle);
	}else
	{
		
		distance += obj1.box.max.z / sin(obj1_angle);

	}
	if(atan2(obj2.box.max.x,obj2.box.max.z) > obj2_angle)
	{
		distance += obj2.box.max.x / cos(obj2_angle);
	}else
	{
		
		distance += obj2.box.max.z / sin(obj2_angle);

	}
	if(distance > sqrt((obj1.pos.x - obj2.pos.x) * (obj1.pos.x - obj2.pos.x) + (obj1.pos.z - obj2.pos.z) * (obj1.pos.z - obj2.pos.z)))
	{
		return true;
	}else
	{
		return false;
	}
	
*/
/*
	if(min1x < max2x && min1y < max2y && min1z < max2z)
	{
		if(min2x < max1x && min2y < max1y && min2z < max1z)
			return true;
	}
*/
	return false;
}

object_cube::object_cube(Position npos,D3DRMBOX nbox)
{
	pos = npos;
	box = nbox;
}
object_cube::object_cube(long PieceID, Position npos,D3DRMBOX nbox) {
	ID = PieceID;
	pos = npos;
	box = nbox;
}
/*
void main(void)
{
	D3DRMBOX box;
	Position pos;
	D3DVECTOR minu;
	
	minu.x = -2.0;
	minu.y = -2.0;
	minu.z = -2.0;
	box.min = minu;

	minu.x = 2.0;
	minu.y = 2.0;
	minu.z = 2.0;
	box.max = minu;
	pos.x = 0;
	pos.y = 0;
	pos.y = 0;
	object_cube cube1(pos,box);
	object_cube cube2(pos,box);
}
*/